package abstractFactory.hk;

import javax.swing.JButton;
import javax.swing.JLabel;

/**
 * This team declares two role classes which are 
 * used to create factory-specific JLabel and JButton products.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public abstract team class ComponentFactoryTeam {

	protected class RLabel extends JLabel {
//		private static final long serialVersionUID = 0L;
		public RLabel(String label) {
			super(label);
		}
	}
	protected class RButton extends JButton {
//		private static final long serialVersionUID = 0L;
		public RButton(String label) {
			super(label);
		}
	}

	public JLabel createLabel() {
		return new RLabel("This Label was created by " + getName());
	}
	public JButton createButton(String label) {
		return new RButton(label);
	}

    /** 	
     * Returns the name of the factory.
     *
     * @return the name of the factory
     */     	  
	public abstract String getName();
}
