package abstractFactory.hk;

import javax.swing.BorderFactory;
import javax.swing.border.Border;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class FramedFactoryTeam extends ComponentFactoryTeam {

	/**
	 * Overrides of the default Label to yield a framed label.
	 */
	protected class RLabel {
//		static final long serialVersionUID = 0L;
		public RLabel(String label) {
			super(label);
			Border raisedbevel = BorderFactory.createRaisedBevelBorder();
			Border loweredbevel = BorderFactory.createLoweredBevelBorder();
			setBorder(BorderFactory.createCompoundBorder(raisedbevel, loweredbevel));
		}
	}

	protected class RButton {
//		static final long serialVersionUID = 0L;
		public RButton(String label) {
			super(label);
			Border raisedbevel = BorderFactory.createRaisedBevelBorder();
			Border loweredbevel = BorderFactory.createLoweredBevelBorder();
			setBorder(BorderFactory.createCompoundBorder(raisedbevel,
					loweredbevel));
		}
	}

	/**
	 * Returns the name of the factory.
	 * 
	 * @return the name of the factory
	 */
	public String getName() {
		return "Framed Factory";
	}
}
