package abstractFactory.jcooper;

import java.awt.Checkbox;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class ItemGardenListener implements ItemListener {
	private GardenFactory gardenFactory;
	private WindowPanel gardenPanel;

	public ItemGardenListener(GardenFactory factory, WindowPanel panel) {
		gardenFactory = factory;
		gardenPanel = panel;
	}

	public void itemStateChanged(ItemEvent e) {
		gardenFactory.setFactory(((Checkbox) e.getSource()).getLabel());
		gardenPanel.resetNames();
		gardenPanel.repaint();
	}
}
