package abstractFactory.jcooper;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Abstract Factory");
		System.out.println();
		System.out.println("Intent: provide an interface for creating families of related");
		System.out.println("or dependent objects without specifying their concrete classes.");
		System.out.println();
		System.out.println("The window that appears provides a choice between gardens.");
		System.out.println("There are 3 garden types: Vegetable, Annual and Perennial.");
		System.out.println("There are 3 kinds of components for each garden: shade, border");
		System.out.println("and central. This gives rise to a 3x3 table with 9 entries.");
		System.out.println("None of the combinations is illegal and all are supported in");
		System.out.println("this example");
	}

	public static void main(String[] args) {
		printHelpMessage();
		new Window4AbstractFactory("Garden planner");
	}
}
