package abstractFactory.jcooper;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Panel;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class WindowPanel extends Panel {
	private static final long serialVersionUID = 0L;
	private String borderPlant, centerPlant, shadePlant;

	public WindowPanel() {
		resetNames();
	}

	public void resetNames() {
		borderPlant = "";
		centerPlant = "";
		shadePlant = "";
	}

	public void setCenter(String newCenterPlant) {
		centerPlant = newCenterPlant;
	}

	public void setBorder(String newBorderPlant) {
		borderPlant = newBorderPlant;
	}

	public void setShade(String newShadePlant) {
		shadePlant = newShadePlant;
	}

	public void paint(Graphics graphics) {
		Dimension size = getSize();
		graphics.setColor(Color.LIGHT_GRAY);
		graphics.fillArc(0, 0, 80, 80, 0, 360);
		graphics.setColor(Color.BLUE);
		graphics.drawRect(0, 0, size.width - 1, size.height - 1);
		graphics.drawString(centerPlant, 100, 50);
		graphics.drawString(borderPlant, 75, 120);
		graphics.drawString(shadePlant, 10, 40);
	}
}
