package adapter.hk;

/**
 * Provides a specialized print method. Acts as the Adaptee in the
 * pattern context.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class SystemOutPrinter {

	/**
	 * Prints the argument string to System.out. In the pattern
	 * context, this is the specificRequest() method on the
	 * Adaptee.
	 * 
	 * @param s
	 *            the string to be printed
	 * @see Writer#write(String) the adapted method
	 */
	public void printToSystemOut(String s) {
		System.out.println(s.toUpperCase());
	}
}