package adapter.hk;

/**
 * Declares the target interface with a general output method. Acts as the
 * Target in the pattern context.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public interface Writer {

	/**
	 * Prints the argument string. In the pattern context, this is the
	 * request() method on the Target.
	 * 
	 * @param s the string to print
	 * @see PrinterAdapter
	 */
	public void write(String s);
}