package adapter.jcooper;

import javax.swing.JList;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import jcooper_support.AwtList;
import jcooper_support.JListData;

/**
 * this is a simple adapter class to convert List awt methods to Swing methods.
 * 
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class JListAdapterTeam {

	public class JawtListR extends JList
			implements ListSelectionListener, AwtList {
		private static final long serialVersionUID = 0L;

		private JListData _listContents;

		public JawtListR() {
			_listContents = new JListData();
			setModel(_listContents);
			setPrototypeCellValue("Abcdefg Hijkmnop");
		}

		public void add(String s) {
			_listContents.addElement(s);
		}

		public void remove(String s) {
			_listContents.removeElement(s);
		}

		public String[] getSelectedItems() {
			Object[] obj = getSelectedValues();
			String[] s = new String[obj.length];
			for (int i = 0; i < obj.length; i++)
				s[i] = obj[i].toString();
			return s;
		}

		public void valueChanged(ListSelectionEvent e) {
		}
	}
}
