package adapter.jcooper;

import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import jcooper_support.AwtList;
import jcooper_support.JListData;

/**
 * this is a simple adapter class to convert List awt methods to Swing methods.
 * 
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class ListAdapterTeam {

	public class JawtListR extends JScrollPane implements
			ListSelectionListener, AwtList {
		private static final long serialVersionUID = 0L;
		private JList listWindow;
		private JListData listContents;

		public JawtListR() {
			listContents = new JListData();
			listWindow = new JList(listContents);
			listWindow.setPrototypeCellValue("Abcdefg Hijkmnop");
			getViewport().add(listWindow);

		}

		public void add(String s) {
			listContents.addElement(s);
		}

		public void remove(String s) {
			listContents.removeElement(s);
		}

		public String[] getSelectedItems() {
			Object[] obj = listWindow.getSelectedValues();
			String[] s = new String[obj.length];
			for (int i = 0; i < obj.length; i++)
				s[i] = obj[i].toString();
			return s;
		}

		public void valueChanged(ListSelectionEvent e) {
		}
	}

}
