/*
 * Created on 6/Jul/2004
 */
package adapter.jcooper;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Adapter");
		System.out.println();
		System.out.println("Intent: convert the interface of a class into another interface");
		System.out.println("clients expect. Adapter lets classes work together that couldn't");
		System.out.println("otherwise because of incompatible interfaces");
		System.out.println();
		System.out.println("The window that appears has two (empty) lists of names.");
		System.out.println("To add a name to the left list, type it in the text field above");
		System.out.println("and click on the 'Insert' button.");
		System.out.println("To move a name from the left list to the right list, select it");
		System.out.println("and click on 'Add'");
		System.out.println("To move a name from the right list back to the left list, select it");
		System.out.println("and click on 'Remove'");
	}

	public static void main(String[] args) {
		printHelpMessage();
		final ListAdapterTeam listTeam = new ListAdapterTeam();
		final JListAdapterTeam jlistTeam = new JListAdapterTeam();
		new Window4Adapter(listTeam, jlistTeam);
	}
}
