package adapter.jcooper;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import jcooper_support.JxFrame;


/**
 * Demonstration of simple Two-list program using JFC controls.
 * This class was formerly named JTowList.
 * 
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Window4Adapter extends JxFrame implements ActionListener {
	private static final long serialVersionUID = 0L;

	private JButton Add, MoveRight, MoveLeft;
	private TextField txt;
	final private ListAdapterTeam _listAdapterTeam;
	final private JListAdapterTeam _jListAdapterTeam;
	private JawtListR<@_listAdapterTeam> leftList;
	private JawtListR<@_jListAdapterTeam> rightList;

	public Window4Adapter(
			final ListAdapterTeam leftAdapterTeam,
			final JListAdapterTeam rightAdapterTeam) {
		super("Two Lists");
		_listAdapterTeam = leftAdapterTeam;
		_jListAdapterTeam = rightAdapterTeam;
		setGUI();
	}

	private void setGUI() {
		getContentPane().setLayout(new GridLayout(1, 2)); //two columns
		setBackground(Color.lightGray);
		JPanel pLeft = new JPanel();
		JPanel pRight = new JPanel();
		getContentPane().add(pLeft);
		getContentPane().add(pRight);
		pLeft.setLayout(new BorderLayout());
		JPanel pTop = new JPanel();
		pLeft.add("North", pTop);
		txt = new TextField(15);
		pTop.add(txt);
		Add = new JButton("Insert");
		Add.setMargin(new Insets(0, 0, 0, 0));
		pTop.add(Add);
		JPanel rBorder = new JPanel();
		rBorder.setLayout(new GridLayout(2, 1));
		MoveRight = new JButton("Add --->");
		MoveLeft = new JButton("<--- Remove");
		JPanel rbTop = new JPanel();
		rbTop.add(MoveRight);
		rBorder.add(rbTop);
		JPanel rbBot = new JPanel();
		rbBot.add(MoveLeft);
		rBorder.add(rbBot);
		pLeft.add("East", rBorder);
		leftList = new JawtListR<@_listAdapterTeam>();
		JScrollPane lsp = new JScrollPane();
		pLeft.add("Center", lsp);
		lsp.getViewport().add(leftList);
		pLeft.add("Center", leftList);
		rightList = new JawtListR<@_jListAdapterTeam>();
		pRight.setLayout(new BorderLayout());
		pRight.add("Center", rightList);
		//Add button action listenes
		Add.addActionListener(this);
		MoveRight.addActionListener(this);
		MoveLeft.addActionListener(this);
		setSize(new Dimension(400, 300));
		setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		JButton b = (JButton)e.getSource();
		if (b == Add)
			addName();
		if (b == MoveRight)
			moveNameRight();
		if (b == MoveLeft)
			moveNameLeft();
	}

	private void addName() {
		if (txt.getText().length() > 0) {
			leftList.add(txt.getText());
			txt.setText("");
		}
	}
	private void moveNameRight() {
		String sel[] = leftList.getSelectedItems();
		if (sel.length > 0) {
			rightList.add(sel[0]);
			leftList.remove(sel[0]);
		}
	}
	
	public void moveNameLeft() {
		String sel[] = rightList.getSelectedItems();
		if (sel.length > 0) {
			leftList.add(sel[0]);
			rightList.remove(sel[0]);
		}
	}
}
