package bridge.hk;

/**
 * Prints capitalized text and uses double crosses ("#") to decorate. Represents
 * a ConcreteImplementation in the context of the Bridge design pattern.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class CrossCapitalImplementation extends ScreenImplementation {

	/**
	 * Does a line feed (to System.out).
	 */
//	public void printLine() {
//		System.out.println();
//	}

	/**
	 * Prints a double cross ("#") to System.out.
	 */
	public void printDecor() {
		System.out.print("X");
	}

	/**
	 * Prints the argument text in capitals to System.out.
	 * 
	 * @param text
	 *            the text to print
	 */
	public void printText(String text) {
		System.out.print(text.toUpperCase());
	}
}
