/*
   4 de Out de 2010
*/
package bridge.hk;

public abstract team class ScreenTeam {
	protected Screen _screen;

	public abstract class Screen playedBy ScreenImplementation {
		public abstract void printLine();
		printLine -> printLine;

		public abstract void printDecor();
		printDecor -> printDecor;

		public abstract void printText(String text);
		printText -> printText;

		/**
		 * Draws or prints a text to an output device determined by the current
		 * Implementor.
		 * @param text The text to be drawn/printed
		 */
		public void drawText(String text) {
			printText(text);
			printLine();
		}

		/**
		 * Draws or prints a text in a box to an output device determined by the
		 * current Implementor.
		 * @param text The text to be drawn/printed
		 */
		public void drawTextBox(String text) {
			int length = text.length();
			for (int i = 0; i < length + 4; i++ ) {
				printDecor();
			}
			printLine();
			printDecor();
			printText(" " + text + " ");
			printDecor();
			printLine();
			for (int i = 0; i < length + 4; i++ ) {
				printDecor();
			}
			printLine();
		}
	}

	public void drawText(String text) {
		_screen.drawText(text);
	}
	public abstract void draw();
}
