package bridge.jcooper;

import java.util.*;

import jcooper_support.JawtList;


/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class ProductList extends JawtList {
	private static final long serialVersionUID = 0L;

	private Vector<String> _products;

	public ProductList(Vector<String> products) {
		super(products.size()); // for compatibility
		setProducts(products);
		init();
	}

	private ProductList init() {
		for (int i = 0; i < _products.size(); i++) {
			// take each string apart and keep only
			// the product names, discarding the quntities
			String s = (String) _products.elementAt(i);
			int index = s.indexOf("--"); // separate qty from name
			if (index > 0)
				add(s.substring(0, index));
			else
				add(s);
		}
		return this;
	}

	public void setProducts(Vector<String> prod) {
		this._products = prod;
	}
}