package builder.hk;

/**
 * Implements a ConcreteBuilder that builds textual descriptions of
 * complex objects consisting of type, attributes and values. This version makes
 * use of the default implementation of getResult().
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class TextCreatorTeam extends AbstractCreatorTeam {
	public class Builder {
		/**
		 * Defines a buildPart() operation for type parts.
		 * 
		 * @param newType
		 *            the type to process
		 */
		public void processType(String newType) {
			representation = "This is a new " + newType + ":\n";
		}

		/**
		 * Defines a buildPart() operation for attribute parts.
		 * 
		 * @param newAttribute
		 *            the attribute to process
		 */

		public void processAttribute(String newAttribute) {
			representation += ("Its " + newAttribute + " is ");
		}

		/**
		 * Defines a buildPart() operation for value parts.
		 * 
		 * @param newValue
		 *            the value to process
		 */
		public void processValue(String newValue) {
			representation += (newValue + ".\n");
		}
	}
}
