package chain_of_responsibility;

/**
 * Implements an exception that occurs if an a request reaches the 
 * end of a <i>Chain of Responsibility</i> but remains unhandled. 
 *
 * @see ChainOfResponsibilityProtocol
 * 
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class ChainOfResponsibilityException extends RuntimeException {  
	private static final long serialVersionUID = 0L;

    /**
     * Creates a ChainOfResponsibilityException
     *
     * @param s the error message 
     */
    
	public ChainOfResponsibilityException(String s) {
		super(s);
	}
}