package chain_of_responsibility.hk;

import javax.swing.JFrame;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;   

/** 
 * Represents a regular GUI frame. No pattern-specific modifications are
 * needed here. A WindowListener is added.
 *
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Frame extends JFrame {
	private static final long serialVersionUID = 0L;

    /** 
     * Creates a Frame with a given title that responds 
     * properly to WindowClosing events 
     *
     * @param title the frame title
     */
 	public Frame(String title) {
		super(title);

		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
	}  
}

	
	