package chain_of_responsibility.jcooper;

import javax.swing.border.*;


import java.awt.*;
import java.io.*;

import jcooper_support.JawtList;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class FileList extends JawtList {
	private static final long serialVersionUID = 0L;

	private String _files[];

	public FileList(String filePath) {
		super(10);
		setBorder(new CompoundBorder(new EmptyBorder(5, 5, 5, 5),
				new LineBorder(Color.black)));
		String tmp = "";
		// File dir = new File(System.getProperty("user.dir"));
		File dir = new File(filePath);
		_files = dir.list();
		for (int i = 0; i < _files.length; i++) {
			for (int j = i; j < _files.length; j++) {
				if (_files[i].toLowerCase().compareTo(_files[j].toLowerCase()) > 0) {
					tmp = _files[i];
					_files[i] = _files[j];
					_files[j] = tmp;
				}
			}
		}
		for (int i = 0; i < _files.length; i++)
			add(_files[i]);
	}
}
