/*
   2009/09/23
*/
package chain_of_responsibility.jcooper;

import jcooper_support.Support;

import org.objectteams.Team;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Chain of responsibility");
		System.out.println();
		System.out.println("Intent: avoid coupling the sender of a request to its receiver by giving");
		System.out.println("object a chance to handle the request. Chain the receivingobjects and pass");
		System.out.println("the request along the chain until an objecthandles it.");
		System.out.println();
		System.out.println("Requests are words to be inserted in text field at the left.");
		System.out.println("Insert a word and click button 'Send' below the text field.");
		System.out.println();
		System.out.println("The chain of handlers is the following, in this order:");
		System.out.println("(1) loader of jpg images, shown top left (see available files in the list at the middle)");
		System.out.println("    try names such as \"mandrill\", \"elliott\" and \"dukegrass\".");
		System.out.println("(2) commands for colours, to fill botton middle area (red, green or blue)");
		System.out.println("(3) any other words are shown at the right list.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		CoRTeam chainTeam = new CoRTeam();
		chainTeam.activate(Team.ALL_THREADS);
		new Window4CoR(Support.FOLDER_LOCATION, chainTeam);
	}
}
