package command.jcooper;

import org.objectteams.Team;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Command");
		System.out.println();
		System.out.println("Intent: encapsulate a request as an object, thereby letting you");
		System.out.println("parameterize clients with different requests, queue or log");
		System.out.println("requests, and support undoable operations.");
		System.out.println();
		System.out.println("This is the version with an active command.");
		System.out.println("Click on the button to turn the background window red.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		MenuCommandTeam commandTeam = new MenuCommandTeam();
		commandTeam.activate(Team.ALL_THREADS);
		new Window4Command(commandTeam);
	}
}
