package command.jcooper;

import command.CommandProtocol;
import java.awt.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class MenuCommandTeam extends CommandProtocol {

	public class Invoker {
		public void callCommand(){
			getCommand(this).execute(this);
		}	
	}

	//isto devia poder ser playedBy ClickedInterface (actualizar o OT/J e ver)
	public class ButtonInvoker extends Invoker playedBy MyButton {
		callCommand <- after clicked;
	}

	public class MenuInvoker extends Invoker playedBy MyMenuItem {
		public void callCommand(){
			getCommand(this).execute(this);
		}	
		callCommand <- after clicked;
	}

	public class Command playedBy AbstractCommand {
		execute -> executeCommand;
	}

	public <AnyBase base Invoker> void execute(AnyBase as Invoker i){
		getCommand(i).execute(i);
	}

	public <AnyBase base Invoker> void setCommand(AnyBase as Invoker i, AbstractCommand as Command c){
		super.setCommand(i, c);
	}
}
