package command.jcooper;

import java.awt.*;
import java.awt.event.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Window4Command extends Frame implements ActionListener {
	private static final long serialVersionUID = 0L;

	private Menu mnuFile;
	private MyMenuItem mnuOpen, mnuExit;
	private MyButton btnRed;
	private static Panel p;
	private static Frame fr;

	public Window4Command(MenuCommandTeam commandTeam) {
		super("Frame without commands");
		fr = this; // save frame object
		MenuBar mbar = new MenuBar();
		setMenuBar(mbar);
		mnuFile = new Menu("File", true);
		mbar.add(mnuFile);
		mnuOpen = new MyMenuItem("Open...");
		commandTeam.setCommand(mnuOpen, new FileOpenCommand());
		mnuOpen.addActionListener(this);
		mnuFile.add(mnuOpen);
		mnuExit = new MyMenuItem("Exit");
		commandTeam.setCommand(mnuExit, new FileExitCommand());
		mnuFile.add(mnuExit);
		mnuExit.addActionListener(this);
		btnRed = new MyButton("Red");
		p = new Panel();
		add(p);
		p.add(btnRed);
		btnRed.addActionListener(this);
		commandTeam.setCommand(btnRed, new ButtonRedCommand());
		setBounds(100, 100, 200, 100);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		ClickedInterface obj = (ClickedInterface) e.getSource();
		obj.clicked();
	}

	public static Frame getFrame() {
		return fr;
	}

	public static Panel getPanel() {
		return p;
	}
}
