package composite.hk1;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Directory {
    /**
     * stores the name of this Directory
     */
	protected String name;

    /**
     * Creates a new Directory with a given name
     *
     * @param name the name for the new Directory object
     */
	public Directory(String name) {
		this.name = name;
	}

    /**
     * Overwrites the toString() method from Object
     * to print information about this Directory
     */
	public String toString() {
		return ("Directory: "+name);
	}

	/**
	 * Returns the size of this Directory. For simplicity, we define that only
	 * files have a tangible size, so this method returns 0.
	 * 
	 * @return the size of the component (on disk)
	 */
	public int getSize() {
		return 0;
	}
}
		