package composite.hk1;

import composite.CompositeProtocol;
import java.util.Enumeration;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class FileSystemCompositeTeam extends CompositeProtocol {
	private static int _indent = 0;

	public class Composite implements ILowerable playedBy Directory {
		public void operation(){
			indent();
			System.out.println(((Directory)this.lower()).toString());
			_indent +=4;                
			tsuper.operation();
			_indent -= 4;			
		}
	}

	private static void indent() {
		for (int i=0; i<_indent; i++)
			System.out.print(" ");
	}

	public class Leaf implements ILowerable playedBy File {
		public void operation(){
			System.out.println(((File)this.lower()).toString());
		}
	}
	
	
	public void addChild(Directory as Composite parent, Directory as Composite child) {	
		parent.add(child);
	}

	public void addChild(Directory as Composite parent,File as Leaf child) {	
		parent.add(child);
	}

	public Enumeration getChildren(Directory as Composite parent){
		return parent.getChildren();
	}

	public void printStructure(Directory as Composite comp){
		comp.operation();
	}
}
