package composite.hk1;

public class Main {

	/**
	 * This example creates a simple structure as follows: Composite directory1
	 * has three children: file1, directory2, and file3. directory2 has file2 as
	 * a child.
	 * 
	 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
	 * @author Joao Gomes - adapted to Object Teams/Java
	 */
	public static void main(String[] args) {
		System.out
				.println("\n<<< Sample OOP implementation of Composite pattern >>>\n");
		System.out.print("Creating Composite structure ...\n");

		Directory directory1 = new Directory("Directory1");
		Directory directory2 = new Directory("Directory2");
		File file1 = new File("File1", 123);
		File file2 = new File("File2", 4556);
		File file3 = new File("File3", 16);

		FileSystemCompositeTeam fsct = new FileSystemCompositeTeam();
		fsct.activate();
		fsct.addChild(directory1, file1);
		fsct.addChild(directory1, directory2);
		fsct.addChild(directory2, file2);
		fsct.addChild(directory1, file3);

		System.out.println("done.");
		System.out.println("This is the Structure:");

		fsct.printStructure(directory1);

		System.out.println("\n<<< Test completed >>>\n");
	}
}