package composite.hk2;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - initially adapted to Object Teams/Java
 * @author Miguel P. Monteiro - second version
 */
public class File {

	/**
	 * stores the name for this File
	 */
	protected String name;

	/**
	 * stores the size for this File
	 */
	protected int size;

	/**
	 * Creates a new File with a given name and size
	 * 
	 * @param name
	 *            the name for the new File
	 * @param size
	 *            the size for the new File
	 */
	public File(String name, int size) {
		this.name = name;
		this.size = size;
	}

	/**
	 * Overwrites the toString() method from Object to
	 * print information about this object
	 */
	public String toString() {
		return ("File: " + name + " (" + size + " KB)");
	}

	/**
	 * Returns the size of this File
	 * 
	 * @return the size of this File (on disk)
	 */
	public int getSize() {
		return size;
	}
}
