package composite.jcooper;

import org.objectteams.Team;

public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Composite");
		System.out.println();
		System.out.println("Intent: compose objects into tree structures to represent part-whole hierarchies.");
		System.out.println("Composite lets clients treat individual objects and compositions of objects uniformly.");
		System.out.println();
		System.out.println("In this implementation, the cost (sum of salaries)");
		System.out.println("is shown in the bottom bar for any employee you");
		System.out.println("click on. ");
		System.out.println("This simple computation calls the getChild()");
		System.out.println("method recursively to obtain all the subordinates");
		System.out.println("of that employee.");
		System.out.println("Data is furnished by the program itself, without external files.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		EmployeeTreeTeam employeeTeam = new EmployeeTreeTeam();
		employeeTeam.activate(Team.ALL_THREADS);
		new Window4Composite(employeeTeam);
	}
}
