package decorator.hk;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 * 
 * A team from this example uses the Object Registration idiom
 */
public class Main {
	/**
	 * Implements the driver for the Decorator design pattern example.<p> 
	 *
	 * Experimental setup: Concrete decorator (ConcreteOutput) prints a
	 * string, Decorators (StarDecorator and BracketDecorator) wrap other
	 * output around it. Output should be: "[ *** <String> *** ]" 
	 */
	public static void main(String[] args) {
	    OutputDecoratorTeam decorator = new OutputDecoratorTeam();
	    decorator.activate();
		ConcreteOutput original = new ConcreteOutput();

		ConcreteOutput decorated = decorator.addStarDecorator(decorator.addBracketDecorator(original));
		System.err.println("Original and decorated obejcts are equal: " +
				(decorated == original));

		original.print("<String>");
		System.out.println();
	}
}
