package decorator.hk;
/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 * 
 * This team uses the Object Registration idiom
 */
public team class OutputDecoratorTeam {
	precedence StarDecorator, BracketDecorator;

	protected class BracketDecorator implements ILowerable playedBy ConcreteOutput
	base when (OutputDecoratorTeam.this.hasRole(base,BracketDecorator.class)) {
		callin void decorateOutput(String s){
			s="["+s+"]";
			base.decorateOutput(s);
		}
		decorateOutput <- replace print;
	}

	protected  class StarDecorator implements ILowerable playedBy ConcreteOutput
	base when (OutputDecoratorTeam.this.hasRole(base,StarDecorator.class)) {
		callin  void decorateOutput(String s) {
			s=" *** "+s+" *** ";
			base.decorateOutput(s);
		}
		decorateOutput <- replace print;
	}

	public ConcreteOutput addBracketDecorator(ConcreteOutput as BracketDecorator c) {
		return c;
	}
	public ConcreteOutput addStarDecorator(ConcreteOutput as StarDecorator c) {
		return c;
	}
}
