package decorator.jcooper;

import org.objectteams.Team;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Decorator");
		System.out.println();
		System.out.println("Intent: Attach additional responsibilities to an object dynamically.");
		System.out.println("Decorators provide a flexible alternative to subclassing for");
		System.out.println("extending functionality.");
		System.out.println();
		System.out.println("In this example, Component is a subclass of JButton.");
		System.out.println("There are 2 decorators: a cool decorator and a");  
		System.out.println("slash decorator.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		ButtonDecoratorTeam buttonDecoratorTeam = new ButtonDecoratorTeam();
		buttonDecoratorTeam.activate(Team.ALL_THREADS);
		new Window4Decorator(buttonDecoratorTeam);
	}
}