package flyweight.hk;

/**
 * A ConcreteFlyweight storing a single regular character
 * 
 * @see PrintableFlyweightFactory
 */
public class CharacterFlyweight extends PrintableFlyweight {

	/**
	 * The character this ConcreteFlyweight represents
	 */
	private char c;

	/**
	 * Creates a new CharacterFlyweight and sets it to represent a particular
	 * character
	 * 
	 * @param c
	 *            the character to represent
	 */
	public CharacterFlyweight(char c) {
		this.c = c;
	}

	/**
	 * Prints the stored character.
	 * 
	 * @param uppercase
	 *            whether the character should be printed in uppercase
	 */
	public void print(boolean uppercase) {
		System.out.print(uppercase ? Character.toUpperCase(c) : c);
	}
}
