package flyweight.hk;

import flyweight.FlyweightProtocol;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class FlyweightTeam extends FlyweightProtocol {

	protected class Flyweight implements ILowerable playedBy PrintableFlyweight {
	}

	protected Flyweight createFlyweight(Object key) {
		char cc = ((Character) key).charValue();
		Flyweight flyweight;
		if (Character.isWhitespace(cc))
			flyweight = new Flyweight(new WhitespaceFlyweight(cc));
		else
			flyweight = new Flyweight(new CharacterFlyweight(cc));
		return flyweight;
	}

	public PrintableFlyweight getFlyweight(Object key) {
		return (PrintableFlyweight) super.getFlyweight(key);
	}
}
