package flyweight.hk;

/**
 * Defines the Flyweight interface. Here, the flyweights are characters
 * that offer a single method: print(boolean).
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 * 
 */
public abstract class PrintableFlyweight {

	/**
	 * Defines the method signature for Flyweights' print()
	 * method
	 * 
	 * @param uppercase
	 *            whether the character is to be printed as uppercase
	 */
	public abstract void print(boolean uppercase);
}