package flyweight.hk;

/**
 * A <i>ConcreteFlyweight</i> storing a single whitespace character
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class WhitespaceFlyweight extends PrintableFlyweight {

	/**
	 * The character this flyweight represents
	 */
	private char c;

	/**
	 * Creates a new flyweight and sets it to represent a particular whitespace
	 * character
	 * 
	 * @param c
	 *            the character to represent
	 */
	public WhitespaceFlyweight(char c) {
		this.c = c;
	}

	/**
	 * Prints the stored character.
	 * 
	 * @param uppercase
	 *            whether the character should be printed in uppercase
	 */
	public void print(boolean uppercase) {
		System.out.print(uppercase ? Character.toUpperCase(c) : c);
	}
}
