package flyweight.jcooper;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JPanel;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Folder extends JPanel {
	private static final long serialVersionUID = 0L;
	private static final int W = 50, H = 30;

	private Color _color;

	public Folder(Color color) {
		_color = color;
	}

	public void Draw(Graphics g, int tx, int ty, String name) {
		g.setColor(Color.black); // outline
		g.drawRect(tx, ty, W, H);
		g.drawString(name, tx, ty + H + 15); // title
		g.setColor(_color); // fill rectangle
		g.fillRect(tx + 1, ty + 1, W - 1, H - 1);
		g.setColor(Color.lightGray); // bend line
		g.drawLine(tx + 1, ty + H - 5, tx + W - 1, ty + H - 5);
		g.setColor(Color.black); // shadow lines
		g.drawLine(tx, ty + H + 1, tx + W - 1, ty + H + 1);
		g.drawLine(tx + W + 1, ty, tx + W + 1, ty + H);
		g.setColor(Color.white); // highlight lines
		g.drawLine(tx + 1, ty + 1, tx + W - 1, ty + 1);
		g.drawLine(tx + 1, ty + 1, tx + 1, ty + H - 1);
	}
}