/*
   2009/08/29
*/
package flyweight.jcooper;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Flyweight");
		System.out.println();
		System.out.println("Intent: Use sharing to support large numbers of fine-grained objects efficiently.");
		System.out.println();
		System.out.println("In this example, Folder is the Flyweight and FolderFactoryTeam is the Flyweight factory.");
		System.out.println("There are two kinds of folder: selected and unselected.");
		System.out.println("The context-dependent that the flyweight needs are the coordinates and the name to");
		System.out.println("be drawn into the folder. That data becomes extrinsic to the Folder class.");
		System.out.println("The main method must calculate the position of each folder as part of ");
		System.out.println("its paint routine and then pass the coordinates to the folder instance.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		FlyweightTeam folderFactoryTeam = new FlyweightTeam();
		new Window4Flyweight(folderFactoryTeam);
	}
}
