package interpreter.jcooper;

import jcooper_support.Support;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Interpreter");
		System.out.println();
		System.out.println("Intent: Given a language, define a represention for its grammar");
		System.out.println("along with an interpreter that uses the representation");
		System.out.println("to interpret sentences in the language.");
		System.out.println();
		System.out.println("Supported grammar is: Print var[var] [sortby var [thenby var]]");
		System.out.println("For convenience, the language is non-recursive and case insensitive.");
		System.out.println("Each statement is a declaration, there is only one verb: print");
		System.out.println("There is no assignment statement or computational ability.");
		System.out.println();
		System.out.println("In the window, try the following expressions:");
		System.out.println("print lname");
		System.out.println("print lname sortby lname");
		System.out.println("print time frname lname sortby frname");
		System.out.println("print time frname lname sortby time");
	}
	public static void main(String[] args) {
		printHelpMessage();
		new Window4Interpreter(Support.FOLDER_LOCATION + "\\" + "50free.txt");
	}
}
