package interpreter.jcooper;


import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;

import jcooper_support.JawtList;
import jcooper_support.JxFrame;
import jcooper_support.KidData;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class Window4Interpreter extends JxFrame {
	private static final long serialVersionUID = 0L;
	private JButton _goTextField;
	private JTextField _textField;
	private KidData _kidData;
	private JawtList _ptable;

	public Window4Interpreter(String filename) {
		super("Interpreter Demo");
		_textField = new JTextField(20);
		_goTextField = new JButton("Go");
		JPanel p = new JPanel();
		getContentPane().add(p);
		p.setLayout(new BorderLayout());
		JPanel np = new JPanel();
		p.add("North", np);
		np.add(_textField);
		np.add(_goTextField);
		_goTextField.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ParserTeam p = new ParserTeam(_textField.getText());
				p.setData(_kidData, _ptable);
				p.execute();
			}
		});
		_ptable = new JawtList(20);
		p.add("Center", _ptable);
		_kidData = new KidData(filename);
		setSize(new Dimension(400, 600));
		setVisible(true);
	}
}
