package iterator.hk;

/**
 * Defines an interface for a basic list.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public interface SimpleList {

	/**
	 * Returns the number of elements in the list
	 * 
	 * @return the number of elements in the list
	 */
	public int count();

	/**
	 * Appends an object to the list
	 * 
	 * @param o
	 *            the object to append
	 * @return true if successful, false otherwise
	 */
	public boolean append(Integer integer);

	/**
	 * Removes an object from the list
	 * 
	 * @param o
	 *            the object to remove
	 * @return true if successful, false otherwise
	 */

	public boolean remove(Integer integer);

	/**
	 * Returns an object from the list
	 * 
	 * @param index
	 *            the position of the object
	 * @return the object at position index
	 */
	public Integer get(int index);
}
