package iterator.jcooper;

import java.util.Iterator;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.util.Enumeration;

import jcooper_support.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Window4Iterator extends JxFrame /* implements ActionListener */{
	private static final long serialVersionUID = 0L;
	private JawtList _kidList, _kidClubList;
	private JTextField _clubForQuery;
	private JButton _getButton;
	private KidDataTeam _kidDataTeam;

	public Window4Iterator(KidDataTeam kidsIteratorTeam) {
		super("OT/J Iterator demo");
		JPanel panel = new JPanel();
		getContentPane().add(panel);
		panel.setLayout(new GridLayout(1, 2));
		JPanel leftPanel = new JPanel();
		JPanel rightPanel = new JPanel();
		panel.add(leftPanel);
		panel.add(rightPanel);
		leftPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		rightPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		_kidList = new JawtList(20);
		leftPanel.setLayout(new BorderLayout());
		leftPanel.add("Center", _kidList);
		rightPanel.setLayout(new BorderLayout());
		_clubForQuery = new JTextField(10);
		_getButton = new JButton("Get");
		_getButton.addActionListener(new GetAction());
		JPanel rightTop = new JPanel();
		rightPanel.add("North", rightTop);
		rightTop.add(_clubForQuery);
		rightTop.add(_getButton);
		_kidClubList = new JawtList(20);
		rightPanel.add("Center", _kidClubList);
//		_kidsIttTeam = new KidData(fileName);
		_kidDataTeam = kidsIteratorTeam;
		fillKidList();
		setSize(new Dimension(400, 300));
		setVisible(true);
	}

	private void fillKidList() {
		Enumeration<Kid> kids = _kidDataTeam.elements();
		while (kids.hasMoreElements()) {
			Kid kid = (Kid) kids.nextElement();
			_kidList.add(kid.getFrname() + " " + kid.getLname());
		}
	}

	private class GetAction implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String clubName = _clubForQuery.getText();
			if (clubName.trim().length() > 0) {
				Iterator<Kid> kidsFromClubItt = _kidDataTeam.getKidsInClubItt(clubName);
				addToList(kidsFromClubItt, _kidClubList);
			}
		}
	}

	private static void addToList(Iterator<Kid> iter, JawtList list) {
		while (iter.hasNext()) {
			Kid kid = (Kid) iter.next();
			list.add(kid.getFrname() + " " + kid.getLname());
		}
	}
}
