package jcooper_support;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 * @author James Cooper, adapted and refactored by Miguel Pessoa Monteiro
 */
public class JxFrame extends JFrame {
	private static final long serialVersionUID = 0L;

	public JxFrame(String title) {
		super(title);
		setCloseClick();
		setLF();
	}

	private void setCloseClick() {
		// create window listener to respond to window close click
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
	}

	private void setLF() {
		// Force SwingApp to come up in the System L&F
		String laf = UIManager.getSystemLookAndFeelClassName();
		try {
			UIManager.setLookAndFeel(laf);
		} catch (UnsupportedLookAndFeelException exc) {
			System.err.println("JxFrame warning: UnsupportedLookAndFeel: "
					+ laf);
		} catch (Exception exc) {
			System.err.println("JxFrame error loading look & feel " + laf
					+ ": " + exc);
		}
	}
}
