package jcooper_support;

import java.util.*;

public class KidData {
	protected Vector<Kid> _kids;

	public KidData(Kid[] kids) {
		_kids = new Vector<Kid>();
		for(Kid k : kids)
			_kids.add(k);
	}

	public KidData(String filename) {
		_kids = new Vector<Kid>();
		InputFile f = new InputFile(filename);
		String s = f.readLine();
		while (s != null) {
			if (s.trim().length() > 0) {
				Kid k = new Kid(s);
				_kids.addElement(k);
			}
			s = f.readLine();
		}
	}

	public Kid[] getData() {
		Kid[] kd = new Kid[_kids.size()];
		for (int i = 0; i < _kids.size(); i++)
			kd[i] = (Kid) _kids.elementAt(i);
		return kd;
	}

	public int size() {
		return _kids.size();
	}

	public Kid getKid(int i) {
		return (Kid) _kids.elementAt(i);
	}

	public Vector<Object> getKidData(int key) {
		Vector<Object> v = new Vector<Object>();
		for (int i = 0; i < _kids.size(); i++)
			v.addElement(getKid(i).getData(key));
		return v;
	}

	public int getTableKey(String tabName) {
		int key = -1;
		tabName = tabName.toLowerCase();
		if (tabName.equals("frname"))
			key = ParseVar.FRNAME;
		if (tabName.equals("lname"))
			key = ParseVar.LNAME;
		if (tabName.equals("age"))
			key = ParseVar.AGE;
		if (tabName.equals("club"))
			key = ParseVar.CLUB;
		if (tabName.equals("time"))
			key = ParseVar.TIME;

		return key;
	}

	public String getTableName(int i) {
		String name = "";
		switch (i) {
		case ParseVar.FRNAME:
			name = "frname";
		case ParseVar.LNAME:
			name = "lname";
		case ParseVar.AGE:
			name = "age";
		case ParseVar.CLUB:
			name = "club";
		case ParseVar.TIME:
			name = "time";
		}
		return name;
	}
}
