package jcooper_support;

import java.util.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class Stack<T> {
	private Vector<T> _stack;

	public Stack() {
		_stack = new Vector<T>();
	}

	public void push(T obj) {
		_stack.addElement(obj);
	}

	public T pop() {
		T obj = _stack.lastElement();
		int i = _stack.size() - 1;
		_stack.removeElementAt(i);
		return obj;
	}

	public void dump(String s) {
		dump();
	}

	public void dump() {
		for (int i = 0; i < _stack.size(); i++)
			_stack.elementAt(i);
	}

	public T top() {
		return _stack.lastElement();
	}

	public boolean hasMoreElements() {
		return (_stack.size() > 0);
	}

	public T nextTop() {
		int i = _stack.size();
		if (i > 1)
			return _stack.elementAt(i - 2);
		return null;
	}

	public void pop2Push(T p) {
		int i = _stack.size();
		if (i >= 2) {
			pop();
			pop();
			push(p);
		} else
			push(p);
	}
}
