package mediator.hk;

import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * Basically a JButton with an ActionListener. The
 * listener calls clicked() when the button gets pressed.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Button extends JButton {
	private static final long serialVersionUID = 0L;

	/**
	 * Creates a new Button object with the provided label.
	 * 
	 * @param name
	 *            the label for the new Button object
	 */
	public Button(String name) {
		super(name);
		this.setActionCommand(name);
		this.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				clicked();
			}
		});
	}

	public void clicked() {
	}
}
