package mediator.jcooper;

import java.util.Enumeration;
import java.util.NoSuchElementException;

import jcooper_support.Kid;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class KidClub implements Enumeration<Kid> {
	private String clubMask;
	private Kid kid;
	private Enumeration<Kid> ke;
	private KidData kdata;

	public KidClub(KidData kd, String club) {
		clubMask = club;
		kdata = kd;
		kid = null;
		ke = kdata.elements();
	}

	public boolean hasMoreElements() {
		boolean found = false;
		while (ke.hasMoreElements() && !found) {
			kid = (Kid) ke.nextElement();
			found = kid.getClub().equals(clubMask);
		}
		if (!found)
			kid = null;
		return found;
	}

	public Kid nextElement() {
		if (kid != null)
			return kid;
		throw new NoSuchElementException();
	}
}