package mediator.jcooper;

import java.util.*;

import jcooper_support.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class KidData {
	private Vector<Kid> _kids;

	public KidData(String filename) {
		_kids = new Vector<Kid>();
		InputFile f = new InputFile(filename);
		String s = f.readLine();
		while (s != null) {
			if (s.trim().length() > 0) {
				Kid k = new Kid(s);
				_kids.addElement(k);
			}
			s = f.readLine();
		}
	}

	public Kid[] getData() {
		Kid[] kids = new Kid[_kids.size()];
		for (int i = 0; i < _kids.size(); i++)
			kids[i] = (Kid) _kids.elementAt(i);
		return kids;
	}

	public Enumeration<Kid> elements() {
		return _kids.elements();
	}

	public Enumeration<Kid> kidsInClub(String club) {
		return new KidClub(this, club);
	}

	public int size() {
		return _kids.size();
	}

	public Kid getKid(int i) {
		return (Kid) _kids.elementAt(i);
	}

	public Vector<Kid> getKidData(int key) {
		Vector<Kid> v = new Vector<Kid>();
		for (int i = 0; i < _kids.size(); i++)
			v.addElement((Kid)getKid(i).getData(key));
		return v;
	}

	public int getTableKey(String tabName) {
		int key = -1;
		tabName = tabName.toLowerCase();
		if (tabName.equals("frname"))
			key = ParseVar.FRNAME;
		if (tabName.equals("lname"))
			key = ParseVar.LNAME;
		if (tabName.equals("age"))
			key = ParseVar.AGE;
		if (tabName.equals("club"))
			key = ParseVar.CLUB;
		if (tabName.equals("time"))
			key = ParseVar.TIME;
		return key;
	}

	public String getTableName(int i) {
		String name = "";
		switch (i) {
		case ParseVar.FRNAME:
			name = "frname";
		case ParseVar.LNAME:
			name = "lname";
		case ParseVar.AGE:
			name = "age";
		case ParseVar.CLUB:
			name = "club";
		case ParseVar.TIME:
			name = "time";
		}
		return name;
	}
}