package mediator.jcooper;

import javax.swing.JList;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.util.Enumeration;

import jcooper_support.JawtList;
import jcooper_support.Kid;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class KidList extends JawtList implements ListSelectionListener {
	private static final long serialVersionUID = 0L;

	private KidData kdata;

	public KidList() {
		super(20);
		kdata = new KidData("files\\50free.txt");
		fillKidList();
		addListSelectionListener(this);
	}

	public void valueChanged(ListSelectionEvent ls) {
		JList obj = (JList) ls.getSource();
		if (obj.getSelectedIndex() >= 0)
			executeSelection();
	}

	private void executeSelection() {
	}

	private void fillKidList() {
		Enumeration<Kid> ekid = kdata.elements();
		while (ekid.hasMoreElements()) {
			Kid k = (Kid) ekid.nextElement();
			add(k.getFrname() + " " + k.getLname());
		}
	}
}
