/*
   2009/09/23
*/
package mediator.jcooper;

import jcooper_support.Support;

import org.objectteams.Team;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Mediator design pattern, second implementation");
		System.out.println();
		System.out.println("Intent: define an object that encapsulates how a set of objects interact.");
		System.out.println("Mediator promotes loose coupling by keeping objects from referring to");
		System.out.println("each other explicitly, and it lets you vary their interaction");
		System.out.println("independently.");
		System.out.println();
		System.out.println("When the program starts, the Copy and Clear buttons are disabled.");
		System.out.println("When you select a name in the left list, it is copied into the text field");
		System.out.println("for editing, and the Copy button is enabled.");
		System.out.println("When you click on Copy, that text is added to the right list, and the");
		System.out.println("Clear button is enabled.");
		System.out.println("Clicking on Clear button, clears the right list and the text field and");
		System.out.println("the list box is deselected and the two buttons are again disabled.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		MediatorTeam mediatorTeam = new MediatorTeam();
		mediatorTeam.activate(Team.ALL_THREADS);
		new Window4Mediator(Support.FOLDER_LOCATION + "\\" + "50free.txt", mediatorTeam);
	}
}
