/*
   2 de Ago de 2010
*/
package mediator.jcooper;

import mediator.MediatorProtocol;
/**
 * @author Miguel P. Monteiro
 */
public team class MediatorTeam extends MediatorProtocol {
	private ClearButtonColleague _clearButton;
	private MoveButtonColleague _moveButton;
	private KTextFieldColleague _kidTextFiled;
	private KidListColleague _kidList;
	private PickedKidsListColleague _pickedKids;

	/* COLLEAGUES */
	protected class ClearButtonColleague extends Colleague playedBy ClearButton {
		private ClearButtonColleague(ClearButton c) {
			_clearButton = this;
		}
		public void colleagueChanged() {
			clear();
		}
		colleagueChanged <- after execute;

		protected abstract void setEnabled(boolean b);
		setEnabled -> setEnabled;
	}	

	protected class MoveButtonColleague extends Colleague playedBy MoveButton {
		private MoveButtonColleague(MoveButton c) {
			_moveButton = this;
		}
		public void colleagueChanged() {
			move();
		}
		colleagueChanged <- after execute;

		protected abstract void setEnabled(boolean b);
		setEnabled -> setEnabled;
	}

	protected class KTextFieldColleague extends Colleague playedBy KTextField {
		private KTextFieldColleague(KTextField c) {
			_kidTextFiled = this;
		}
		protected abstract void setText(String s);
		setText -> setText;

		protected abstract String getText();
		String getText() -> String getText();
	}

	protected class PickedKidsListColleague extends Colleague playedBy PickedKidsList {	
		private PickedKidsListColleague(PickedKidsList c) {
			_pickedKids = this;
		}
		protected abstract void clear();
		clear -> clear;
		
		protected abstract void add(String s);
		void add(String s) -> void add(String s);		
	}

	protected class KidListColleague extends Colleague playedBy KidList {
		public KidListColleague(KidList c) {
			_kidList = this;
		}
		public void colleagueChanged() {
			select();
		}
		colleagueChanged <- after executeSelection;

		protected abstract Object getSelectedValue();
		getSelectedValue -> getSelectedValue;

		protected abstract void clearSelection();
		clearSelection -> clearSelection;
	}
	/*END-COLLEAGUES*/

	//Method for adding bases as roles, to instantiate the private members of 
	//this team instance
	public <AnyBase base Colleague> void setColleague(AnyBase as Colleague c) {
	}

	/* MEDIATOR UPDATE METHODS */
	public void move() {
		_pickedKids.add(_kidTextFiled.getText());
		_clearButton.setEnabled(true);
	}

	public void clear() {
		_kidTextFiled.setText("");
		_moveButton.setEnabled(false);
		_clearButton.setEnabled(false);
		_pickedKids.clear();
		_kidList.clearSelection();
//		System.out.println("Cleared");
	}

	public void select() {
		String s = (String)_kidList.getSelectedValue();
		_kidTextFiled.setText(s);
		_moveButton.setEnabled(true);
//		System.out.println("Selected");
	}
}
