package mediator.jcooper;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import jcooper_support.ICommand;
import jcooper_support.JxFrame;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Window4Mediator extends JxFrame implements ActionListener {
	private static final long serialVersionUID = 0L;

	private KidList _kidList;
	private ClearButton _clearButton;
	private MoveButton _copyButton;
	private KTextField _kidTextFiled;
	private PickedKidsList _pickedKids;

	public Window4Mediator(String fileName, MediatorTeam mediatorTeam) {
		super("Mediator demo");
		JPanel jp = new JPanel();
		getContentPane().add(jp);
		jp.setLayout(new BorderLayout());
		JPanel center = new JPanel();
		JPanel left = new JPanel();
		JPanel right = new JPanel();
		jp.add("Center", center);
		center.setLayout(new GridLayout(1, 2));
		center.add(left);
		center.add(right);
		left.setBorder(new EmptyBorder(5, 5, 5, 5));
		right.setBorder(new EmptyBorder(5, 5, 5, 5));
		_kidList = new KidList();
		mediatorTeam.setColleague(_kidList);
		left.setLayout(new BorderLayout());
		left.add("Center", _kidList);
		right.setLayout(new BorderLayout());
		_kidTextFiled = new KTextField();
		mediatorTeam.setColleague(_kidTextFiled);
		_copyButton = new MoveButton(this);
		mediatorTeam.setColleague(_copyButton);
		_clearButton = new ClearButton(this);
		mediatorTeam.setColleague(_clearButton);
		JPanel rtop = new JPanel();
		jp.add("North", rtop);
		rtop.add(_kidTextFiled);
		rtop.add(_copyButton);
		rtop.add(_clearButton);
		_pickedKids = new PickedKidsList();
		mediatorTeam.setColleague(_pickedKids);
		right.add("Center", _pickedKids);
		mediatorTeam.clear();
		setSize(new Dimension(400, 300));
		setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		ICommand command = (ICommand) e.getSource();
		command.execute();
	}
}
