package memento.hk.confined;

import memento.MementoConfinedProtocol;
/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class ConfinedMementoTeam extends MementoConfinedProtocol {
//	public class Role {} // To be used in comparisons with uses of role Memento  

	//Could have a weak hash map to keep mementos and originators
	public class Memento extends Confined {
		private int state;

//		public Memento() {}
		public Memento(Originator o){
			this.state = (Integer)o.getState();
		}
		public Object getState() {
			return state;
		}
	}

	protected class Originator playedBy Counter {
		getState -> getCurrentValue;
		void setState(Memento m) -> void setCurrentValue(int value) with {
			(Integer)m.getState() -> value
		}
//		public void setState(Memento m){
//			currentValue = (Integer)m.getState() ;
//		}
	}

	public void createMementoFor(Counter as Originator o) {
		super.createMementoFor(o);
	}
	public void setMemento(Counter as Originator o) {
		super.setMemento(o);
	}	
}
