package memento.hk.externalized;

import memento.MementoProtocol;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class MementoTeam extends MementoProtocol {

	protected class Originator playedBy Counter {
		getState -> getCurrentValue;
		void setState(Memento m) -> void setCurrentValue(int value) with {
			(Integer)m.getState() -> value
		}
	}

	public class Memento implements org.objectteams.ITeam.IConfined {
		private Integer state;

		public Memento() {}
		public Memento(Originator o) {
			this.state = (Integer) o.getState();
		}
		public Object getState() {
			return state;
		}
	}

	public Memento createMementoFor(Counter as Originator o) {
		return super.createMementoFor(o);
	}
	public void setMemento(Counter as Originator o, org.objectteams.ITeam.IConfined m) {
		super.setMemento(o, m);
	}
}
