package memento.hk.opaque;

/**
 * Implements a sample Originator class. Objects of this particular Originator
 * have state, an int representing the number of time the increment() method was
 * called.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Counter {
	/**
	 * the number of times increment() was called on this object
	 */
	private int currentValue = 0;

	public int getCurrentValue() {
		return currentValue;
	}

	/**
	 * increments the counter (this Originator's state) by one
	 */
	public void increment() {
		currentValue++;
	}

    /**
     * Displays the state of this Originator
     */
	public void show() {
		System.out.println("Originator value is " + currentValue);
	}

	public void setCurrentValue(int value) {
		this.currentValue = value;
	}
}
