package memento.hk.opaque;

import memento.MementoOpaqueProtocol;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class OpaqueMementoTeam extends MementoOpaqueProtocol {
	// team acts as caretaker
	private IConfined _savedMemento;

	public class Role { }

	protected class Originator playedBy Counter {
		public abstract Integer getState();
		getState -> getCurrentValue;

		void setState(Memento m) -> void setCurrentValue(int value) with {
			(Integer)m.getState() -> value
		}
	}

	protected class Memento implements IConfined {
		private Integer state;

		public Memento() {}
		public Memento(Originator o) {
			this.state = (Integer) o.getState();
		}
		public Object getState() {
			return state;
		}
	}

	public void saveMemento(Counter as Originator o) {
		_savedMemento = super.createMementoFor(o);
	}
	public void restoreMemento(Counter as Originator o) {
		super.setMemento(o, _savedMemento);
	}
}
