package memento.jcooper;

import java.awt.event.ActionListener;
import javax.swing.JButton;

import jcooper_support.ICommand;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class ClearButton extends JButton implements ICommand {
	private static final long serialVersionUID = 0L;
	private Mediator med;

	public ClearButton(ActionListener act, Mediator md) {
		super("C");
		setToolTipText("Clear");
		addActionListener(act);
		med = md;
	}

	public void execute() {
		med.clear();
	}
}
