package memento.jcooper;

import org.objectteams.Team;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Memento design pattern");
		System.out.println();
		System.out.println("Intent: without violating encapsulation, capture and externalize");
		System.out.println("an object's internal state so that the object can be restored to");
		System.out.println("this state later.");
		System.out.println();
		System.out.println("This example has a toolbar with 3 buttons: Rectangle, Undo and Clear.");
		System.out.println("The Rectangle button is a JToggleButton which stays selected until");
		System.out.println("you click the mouse to draw a new rectangle.");
		System.out.println("Once you have drawn rectangles, you can select any of them.");
		System.out.println("Once selected, you can drag the a rectangle to a new position.");
		System.out.println("The Undo button can undo a succession of operations.");
		System.out.println("It can undo moving a rectangle and undo the creation of each rectangle.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		MementoTeam mementoTeam = new MementoTeam();
		mementoTeam.activate(Team.ALL_THREADS);
		new Window4Memento();
	}
}
