package memento.jcooper;

import java.awt.event.ActionListener;
import javax.swing.JToggleButton;

import jcooper_support.ICommand;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class RectButton extends JToggleButton implements ICommand {
	private static final long serialVersionUID = 0L;

	private Mediator med;

	public RectButton(ActionListener act, Mediator md) {
		super("R");
		// setSize(new Dimension(25,25));
		// setBorder(new EmptyBorder(5,5,5,5));
		setToolTipText("Draw rectangle");
		addActionListener(act);
		med = md;
		med.registerRectButton(this);
	}

	public void execute() {
		if (isSelected()) {
			med.startRectangle();
		}
	}
}
