package memento.jcooper;

import java.awt.event.ActionListener;
import javax.swing.JButton;

import jcooper_support.ICommand;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class UndoButton extends JButton implements ICommand {
	private static final long serialVersionUID = 0L;
	private Mediator med;

	public UndoButton(ActionListener act, Mediator md) {
		super("U");
		// setSize(new Dimension(25,25));
		// setBorder(new EmptyBorder(5,5,5,5));
		setToolTipText("Undo");
		addActionListener(act);
		med = md;
	}

	public void execute() {
		med.undo();
	}
}
