package memento.jcooper;

import java.awt.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class VisRectangle {
	private Rectangle rect;
	private boolean selected;
	int _x, _y, _w, _h;

	public VisRectangle(int xpt, int ypt) {
		_x = xpt;
		_y = ypt;
		_w = 40;
		_h = 30;
		saveAsRect();
	}

	public void setSelected(boolean b) {
		selected = b;
	}

	private void saveAsRect() {
		rect = new Rectangle(_x - _w / 2, _y - _h / 2, _w, _h);
	}

	public void draw(Graphics g) {
		g.drawRect(_x, _y, _w, _h);
		if (selected) {
			g.fillRect(_x + _w / 2, _y - 2, 4, 4);
			g.fillRect(_x - 2, _y + _h / 2, 4, 4);
			g.fillRect(_x + _w / 2, _y + _h - 2, 4, 4);
			g.fillRect(_x + _w - 2, _y + _h / 2, 4, 4);
		}
	}

	public boolean contains(int x, int y) {
		return rect.contains(x, y);
	}

	public void move(int xpt, int ypt) {
		_x = xpt;
		_y = ypt;
		saveAsRect();
	}
}
