/*
   Mar 13, 2012
*/
package memento.simple;

/**
 * Simplistic implementation of the HK scenario for Memento 
 * The team acts as caretaker.
 * @author Miguel P. Monteiro
 */
public team class MementoTeam {
	protected class Memento extends Confined {
		private int state;
		protected Memento() {}
		protected Memento(Originator o) { this.state = o.getState(); }
		protected int getState() { return state; }
	}

	protected class Originator playedBy Counter {
		public abstract int getState();
		getState -> getCurrentValue;
		void setState(int value) -> void setCurrentValue(int value);
	}

	protected Memento savedMemento;

	public void getMementoFor(Counter as Originator o) {
		o.setState(savedMemento.getState());
	}
	public void createMementoFor(Counter as Originator o) {
		this.savedMemento = new Memento(o);
	}
	public Memento tryToLeakMemento() {
		return savedMemento;
	}
//	public Object tryToLeakMemento() {
//		return savedMemento;
//	}
}
