package observer.hk;

import java.awt.Color;

import observer.ObserverProtocol;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class ColorObserver extends ObserverProtocol{
	//- s1 and s2 observe color changes to p

	public class Subject playedBy Point {		
		public abstract Color getColor();
		getColor -> getColor;

		notifyObservers <- after setColor;	
	}
	
	public class Observer playedBy Screen {
		public abstract void update(Subject s);
		update -> refresh;
	}

	public void addObserver(Screen as Observer obs , Point as Subject sub ) {
		sub.addObserver(obs);
	}
}
