package observer.hk;

import observer.ObserverProtocol;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class CoordinatesObserver extends ObserverProtocol{
	//- s3 and s4 observe coordinate changes to p

	public class Subject playedBy Point {
		public abstract int getX();
		public abstract int getY();
		
		getX-> getX;
		getY-> getY;
		
		notifyObservers <- after setX;
		notifyObservers <- after setY;
	}

	public class Observer playedBy Screen {
		update -> refresh;
	}

	public void addObserver(Screen as Observer obs , Point as Subject sub ){
		sub.addObserver(obs);
	}
}
