package observer.jcooper;

import java.awt.*;
import javax.swing.JPanel;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class ColorFrame extends Frame {
	private static final long serialVersionUID = 0L;

	private static int _yOffset = 100;
	private Color _color;
	private String _colorName = "none";
	private JPanel _panel = new JPanel(true);

	public ColorFrame() {
		super("Colors"); // set frame caption
		add(_panel, BorderLayout.CENTER);

		setBounds(100, _yOffset, 100, 100);
		_yOffset += 120;
		setVisible(true);
	}

	public void changeColor(String color) {
		// Observer is notified of change here
		_colorName = color; // save color name
		// set background to that color
		if (color.toUpperCase().equals("RED"))
			_color = Color.red;
		if (color.toUpperCase().equals("BLUE"))
			_color = Color.BLUE;
		if (color.toUpperCase().equals("GREEN"))
			_color = Color.green;
		setBackground(_color);
	}

	public void paint(Graphics g) {
		g.drawString(_colorName, 20, 50);
	}
}
