package observer.jcooper;

import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.*;

import jcooper_support.JListData;
import jcooper_support.JxFrame;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class ColorList extends JxFrame {
	private static final long serialVersionUID = 0L;

	private JList _list;
	private JPanel _panel;
	private JScrollPane _scrollPane;
	private JListData _listData;

	public ColorList() {
		super("Color List");

		// Put panel into the frmae
		_panel = new JPanel(true);
		getContentPane().add("Center", _panel);
		_panel.setLayout(new BorderLayout());

		// Create the list
		_listData = new JListData(); // the list model
		_list = new JList(_listData); // the visual list
		_scrollPane = new JScrollPane(); // the scroller
		_scrollPane.getViewport().add(_list);
		_panel.add("Center", _scrollPane);
		_scrollPane.setPreferredSize(new Dimension(100, 100));
		setBounds(250, 100, 100, 500);
		setVisible(true);
	}

	public void writeColorOnWindow(String s) {
		_listData.addElement(s);
	}

}
