package observer.jcooper;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import jcooper_support.JxFrame;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Window4Observer extends JxFrame implements ItemListener {
	private static final long serialVersionUID = 0L;

	public Window4Observer() {
		super("Change 2 other frames");
		JPanel panel = new JPanel(true);
		panel.setLayout(new FlowLayout());
		getContentPane().add("Center", panel);
		RadioButtonsGroup box = new RadioButtonsGroup(this);
		panel.add("Center", box);
		panel.add(new QuitButton());
		setSize(new Dimension(140, 120));
		setVisible(true);
	}

	private class RadioButtonsGroup extends Box {
		private static final long serialVersionUID = 0L;

		private JRadioButton _redButton = new JRadioButton("Red");
		private JRadioButton _greenButton = new JRadioButton("Green");
		private JRadioButton _blueButton = new JRadioButton("Blue");

		public RadioButtonsGroup(ItemListener listener) {
			super(BoxLayout.Y_AXIS);
			// add 3 radio buttons
			this.add(_redButton);
			this.add(_greenButton);
			this.add(_blueButton);
			// listen for clicks on radio buttons
			this._blueButton.addItemListener(listener);
			this._redButton.addItemListener(listener);
			this._greenButton.addItemListener(listener);
			// make all part of same button group
			ButtonGroup bgr = new ButtonGroup();
			bgr.add(_redButton);
			bgr.add(_greenButton);
			bgr.add(_blueButton);
		}
	}
	private class QuitButton extends Button {
		private static final long serialVersionUID = 0L;

		public QuitButton() {
			super("Quit");
			this.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent dummy) {
					System.exit(0);
				}
			});
		}
	}

	public void itemStateChanged(ItemEvent e) {
		// do something

		// if the button is selected
		// if (e.getStateChange() == ItemEvent.SELECTED){
		// 	selectedColor = ((JRadioButton)e.getSource()).getText();
		// 	System.out.println(selectedColor);		
		// }
	}

}
