package prototype.hk1; 

/**
 * Implements a sample <i>Prototype</i> that imitates a simple String
 * class.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class StringPrototypeA {

    /**
     * the string that this object encapsulates
     */      
    protected String text;

    /**
     * Creates a new StringPrototypeA object with the given string
     *
     * @param init the initial String for this object
     */
    public StringPrototypeA(String init) {
        text = init;
    }

    /**
     * Changes the string this object encapsulates
     *
     * @param newText the new text for this object.
     */    
    public void setText(String newText) {
        text = newText;
    }

    /**
     * Returns a string representation of this object.
     *
     * @returns a string representation of this object.
     */
    public String toString() {
        return "StringPrototypeA: "+ text;
    }
}
