package prototype.hk1;

import prototype.PrototypeProtocol;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class StringPrototypeTeam extends PrototypeProtocol {

	protected class PrototypeAR extends PrototypeR playedBy StringPrototypeA {
		public abstract String getText();
		getText -> get text;

		public Object clone() throws CloneNotSupportedException {			
			Object b = super.clone();
			return b;
		}
		public Object deepClone() {
			return new StringPrototypeA(getText());
		}
	}

	protected class PrototypeBR extends PrototypeR playedBy StringPrototypeB {
		String getText() -> get String text;

		public Object clone() throws CloneNotSupportedException {
			return new StringPrototypeB(getText());
		}

		public Object deepClone() {
			return new StringPrototypeB(getText());
		}
	}

	public <AnyBase base PrototypeR> Object createClone(AnyBase as PrototypeR object) {
        try {
            return object.clone();
        } catch (CloneNotSupportedException ex) {
        	return object.deepClone();   
        }
    }

	public <AnyBase base PrototypeR> Object createDeepClone(AnyBase as PrototypeR object) {
		return object.deepClone();
	}
//		doesn't need instanceof's since lifting makes the correct translation 
//		if(object instanceof PrototypeAR)
//			return new StringPrototypeA(((PrototypeAR)object).getText());
//		else if (object instanceof PrototypeBR)
//			return new StringPrototypeB(((PrototypeBR)object).getText());
}
