/*
   24 de Mai de 2010
*/
package prototype.hk2;

/**
 * @author Miguel P. Monteiro
 */
public class Main {
	public static void main(String[] args) {
		System.out.println("Testing the Prototype design pattern implementation...");
		StringPrototype originalA = new StringPrototype("This is Prototype 1");
		StringPrototype originalB = new StringPrototype("This is Prototype 2");

		StringPrototypeTeamA copyA1, copyA2;
		StringPrototypeTeamB copyB1;

		copyA1 = new StringPrototypeTeamA(originalA);
		copyB1 = new StringPrototypeTeamB(originalB);

		System.out.println("These are the two prototypes:");
		System.out.println(originalA);
		System.out.println(originalB);

		System.out.println("These are copies of the prototypes:");
		copyA1.activate();
		copyB1.activate();
		System.out.println(originalA);
		System.out.println(originalB);

		System.out.println("Now prototype 1 is changed. Here are prototype 1 and its former copy:");
		copyA1.deactivate();

		originalA.setText("This is Prototype 1 (changed)");
		copyA2 = new StringPrototypeTeamA(originalA);
		copyA2.activate();
		System.out.println(originalA);
		System.out.println(copyA1);

		System.out.println("This is a clone of the changed prototype 1 and a changed copy of prototype 2:");
		copyB1.setText("  This is a changed copy of prototype 2");
		System.out.println(copyA2);
		System.out.println(copyB1);

		System.out.println("... done.");
	}
}
