/*
   24 de Mai de 2010
*/
package prototype.hk2;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Miguel P. Monteiro - adapted to Object Teams/Java
 * 
 * This team uses Object Registration idiom to ensure that callin methods are
 * activated only if base is the registered object.
 */
public team class StringPrototypeTeamA {
	private String _copy;

	protected class MyStringClone playedBy StringPrototype
			base when (StringPrototypeTeamA.this.hasRole(base, MyStringClone.class)) {
		callin String asString() {
			StringPrototypeTeamA.this._copy = "StringPrototypeA: " + base.asString();
			return _copy;
		}
		asString <- replace toString;
	}

	public StringPrototypeTeamA(StringPrototype as MyStringClone original) {
		//This instance of PrototypeString is automatically registered
		_copy = original.toString();
	}
	public String toString() {
		return _copy;
	}
}
