/*
   24 de Mai de 2010
*/
package prototype.hk2;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Miguel P. Monteiro - adapted to Object Teams/Java
 * 
 * This team uses the (rather crude) technique to register a reference to a
 * specific base through a team field and a role method guard to ensure that
 * callin methods are activated only if base is the registered object.
 * The technique used by StringPrototypeA (Object Registration idiom) seems
 * preferable.
 */
public team class StringPrototypeTeamB {
	private StringPrototype _original;
	private String _copy;

	protected class MyStringClone playedBy StringPrototype
			base when (StringPrototypeTeamB.this._original == base) {
		callin String asString() {
			StringPrototypeTeamB.this._copy = "StringPrototypeB: " + base.asString();
			return _copy;
		}
		asString <- replace toString;
	}
	public StringPrototypeTeamB(StringPrototype original) {
		_original = original;
		setText(original.toString());
	}
	public void setText(String newText) {
		_original.setText(newText);
		_copy = _original.toString();
	}
	public String toString() {
		return _copy;
	}
}
