package prototype.jcooper;

import java.util.*;
import java.io.*;

import jcooper_support.InputFile;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class SwimData implements Cloneable, Serializable {
	private static final long serialVersionUID = 0L;

	protected Vector<Swimmer> swimmers;

	public SwimData() {
	} // mpm

	public SwimData(String filename) {
		String s = "";
		swimmers = new Vector<Swimmer>();
		InputFile f = new InputFile(filename);
		s = f.readLine();
		while (s != null) {
			swimmers.addElement(new Swimmer(s));
			s = f.readLine();
		}
		f.close();
	}

	public int size() {
		return swimmers.size();
	}

	public Swimmer getSwimmer(int i) {
		if ((i >= 0) && (i < swimmers.size()))
			return swimmers.elementAt(i);
		return null;
	}

	public void sortByTime() {
		Swimmer sw;
		int i, j;
		int max = swimmers.size();
		Swimmer sd[] = new Swimmer[max];
		for (i = 0; i < max; i++)
			sd[i] = (Swimmer) swimmers.elementAt(i);
		for (i = 0; i < max; i++) {
			for (j = i; j < max; j++) {
				if (sd[i].getTime() > sd[j].getTime()) {
					sw = sd[i];
					sd[i] = sd[j];
					sd[j] = sw;
				}
			}
		}
		// swimmers = new Vector();
		swimmers.removeAllElements();
		for (i = 0; i < max; i++)
			swimmers.addElement(sd[i]);
	}

	public ObjectOutputStream writeTo(ByteArrayOutputStream b) {
		try {
			ObjectOutputStream out = new ObjectOutputStream(b);
			out.writeObject(this);
			return out;
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
}
//class Swimmer implements Serializable {
//	static final long serialVersionUID = 0L;
//	String name;
//	int age;
//	String club;
//	float time;
//	boolean female;
//	public Swimmer(String dataline) {
//		StringTokenizer st = new StringTokenizer(dataline, ",");
//		name = st.nextToken();
//		age = new Integer(st.nextToken().trim()).intValue();
//		club = st.nextToken().trim();
//		time = new Float(st.nextToken().trim()).floatValue();
//		//System.out.println(name+" "+time);
//		String sx = st.nextToken().trim().toUpperCase();
//		female = sx.equals("F");
//	}
//	public boolean isFemale() {
//		return female;
//	}
//	public int getAge() {
//		return age;
//	}
//	public float getTime() {
//		return time;
//	}
//	public String getName() {
//		return name;
//	}
//	public String getClub() {
//		return club;
//	}
//}
