package prototype.jcooper;

import java.awt.event.*;
import java.awt.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Window4Prototype extends Frame implements ActionListener {
	private static final long serialVersionUID = 0L;

	private SwimData sdata, sxdata = null;
	private List swList, cloneList;
	private Button Clone, Refresh, Quit;
	private Swimmer sw;
	private SwimPrototypeTeam _swimPrototypeTeam;

	public Window4Prototype(String fileName, SwimPrototypeTeam swimPrototypeTeam) {
		super("Prototype example");
		_swimPrototypeTeam = swimPrototypeTeam;
		sdata = new SwimData(fileName);

		setGUI();
		loadswList();
	}

	private void setGUI() {
		setLayout(new GridLayout(1, 3));
		setBackground(Color.lightGray);
		swList = new List(15);
		cloneList = new List(15);
		Panel cp = new Panel();
		add(swList);
		add(cp);
		add(cloneList);
		Clone = new Button("Clone -->");
		Refresh = new Button("<--Refresh");
		Quit = new Button("Quit");
		cp.setLayout(new GridLayout(3, 1));
		Panel p1 = new Panel();
		cp.add(p1);
		p1.add(Clone);
		Panel p2 = new Panel();
		cp.add(p2);
		p2.add(Refresh);
		Panel p3 = new Panel();
		cp.add(p3);
		p3.add(Quit);
		Clone.addActionListener(this);
		Refresh.addActionListener(this);
		Quit.addActionListener(this);
		setBounds(100, 100, 500, 400);
		setVisible(true);
	}

	private void loadswList() {
		swList.removeAll();
		for (int i = 0; i < sdata.size(); i++) {
			sw = sdata.getSwimmer(i);
			swList.add(sw.getName() + " " + sw.getTime());
		}
	}

	private void cloneAndLoad() {
		sxdata = (SwimData) _swimPrototypeTeam.createClone(sdata);
	
		// sxdata = (SwimData) sdata.clone();
		sxdata.sortByTime();
	
		cloneList.removeAll();
		// now print out sorted values from clone
		for (int i = 0; i < sxdata.size(); i++) {
			sw = sxdata.getSwimmer(i);
			cloneList.add(sw.getName() + " " + sw.getTime());
		}
	}

	public void actionPerformed(ActionEvent e) {
		Object obj = e.getSource();
		if (obj == Clone)
			cloneAndLoad();
		if (obj == Refresh)
			loadswList();
		if (obj == Quit)
			System.exit(0);
	}
}
