package proxy.jcooper;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class ImageProxyTeam {
	private MediaTracker tracker;
	private Thread imageCheck; //to monitor loading

	public class Proxy implements Runnable playedBy MyImage {		
		void repaint() -> void repaint();
		Image getImg() -> get Image img;
		int getHeight() -> get int height;
		int getWidth() -> get int width;
		loadImage <- after init;
		paint <- replace paint;

		public void loadImage(){
			tracker = new MediaTracker(this);
			tracker.addImage(getImg(), 0); //watch for image loading
			imageCheck = new Thread(this);
			imageCheck.start(); //start 2nd thread monitor
			try {
				tracker.waitForID(0, 1);
			} catch (InterruptedException e) {}
		}

		callin void paint(Graphics g) {
			if (tracker.checkID(0)) {
				g.setColor(Color.lightGray); //erase box
				g.fillRect(0, 0, getWidth(), getHeight());
				base.paint(g);
				//g.drawImage(_image, 0, 0, this); //draw _loaded image
			} else {
				//draw box outlining image if not _loaded yet
				g.setColor(Color.black);
				g.drawRect(1, 1, getWidth() - 2, getHeight() - 2);
			}
		}

		public void run() {
			//this thread monitors image loading
			//and repaints when done
			//the 1000 msec is artifically long
			//to allow demo to display with delay
			try {
				Thread.sleep(1000);
				while (!tracker.checkID(0))
					Thread.sleep(1000);
			} catch (Exception e) {}
			repaint();
		}
	}	
}
