package proxy.jcooper;

import org.objectteams.Team;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Proxy.");
		System.out.println();
		System.out.println("Intent: provide a surrogate or placeholder for another object");
		System.out.println("to control access to it.");
		System.out.println();
		System.out.println("In this example, a window displays an image when it is _loaded.");
		System.out.println("Rather than loading the image directly, class ImageProxy defers loading");
		System.out.println("and draws a rectangle around the image area until loading is completed.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		ImageProxyTeam imageProxyTeam = new ImageProxyTeam();
		imageProxyTeam.activate(Team.ALL_THREADS);
		new Window4Proxy();
	}
}
