package proxy.jcooper;

import java.awt.*;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class MyImage extends JPanel {

	private static final long serialVersionUID = 0L;
	int height, width;
	Image img;
	JFrame frame;

	public MyImage(String filename, int w, int h) {
		this.height = h;
		this.width = w;
		init(filename);
	}

	public void init(String filename) {
		img = Toolkit.getDefaultToolkit().getImage(filename);
		repaint();
	}

	public void paint(Graphics g) {
		g.drawImage(img, 0, 0, this); // draw image
	}

	public Dimension getPreferredSize() {
		return new Dimension(width, height);
	}

	public int getHeight() {
		return height;
	}

	public int getWidth() {
		return width;
	}
}
