package singleton.jcooper;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
class Printer {
	// this is a prototype for a printer-spooler class
	// such that only one instance can ever exist
	static boolean instance_flag = false; // true if 1 instance

	public Printer() throws SingletonException {
		if (instance_flag)
			throw new SingletonException("Only one printer allowed");
		instance_flag = true; // set flag for 1 instance
		System.out.println("printer opened");
	}

	public void finalize() {
		instance_flag = false;
	}
}
