package state.hk;

public team class StateTeam /*extends AbstractStateTeam*/ {
	protected Object[] items;
	protected int first = 0;
	protected int last = 0;
	protected QueueState currentState;

	public StateTeam() {
		this.currentState = new EmptyState();
		this.items = new Object[3];
	}

//	public 
	protected abstract class QueueState {
		public abstract boolean insert(Object arg);
		public abstract Object  getFirst();	
		public abstract boolean removeFirst();	
	}

//	public 
	protected class EmptyState extends QueueState {
		public boolean insert(Object arg) {
			return true;
		}
		public Object getFirst() {
			return null;
		}
		public boolean removeFirst() {
			return false;
		}
	}

//	public 
	protected class FullState extends QueueState {
		public boolean insert(Object arg) {
			return false;
		}
		public Object getFirst() {
			return items[first];
		}
		public boolean removeFirst() {
			return true;
		}
	}

//	public 
	protected class NormalState extends QueueState {
		public boolean insert(Object arg) {
			items[(last) % items.length] = arg;
			last = (last + 1) % items.length;
			return true;
		}
		/* Returns the first element in the queue */
		public Object getFirst() {
			return items[first];
		}

		/* Removes the first element from the queue */
		public boolean removeFirst() {
			first = (first + 1) % items.length;
			return true;
		}
	}

	// insert auxiliary method
	public boolean insertIntoQueue(Object arg) {
		return this.currentState.insert(arg);
	}

	// sets correct current state and inserts arg into queue (if possible)
	public boolean insert(Object arg) {
		if (currentState instanceof EmptyState) {
			currentState = new NormalState();
		} else if (currentState instanceof NormalState) {
			if (first == last) {
				currentState = new FullState();
			}
		}
		return insertIntoQueue(arg);
	}

	public Object getFirst() {
		return this.currentState.getFirst();
	}

	// removeFirst auxiliary method
	public boolean removeFirstFromQueue() {
		return this.currentState.removeFirst();
	}

	public boolean removeFirst() {
		if (currentState instanceof FullState) {
			currentState = new NormalState();
		} else if (currentState instanceof NormalState) {
			if (first == last) {
				currentState = new EmptyState();
			}
		}
		return removeFirstFromQueue();
	}

	public void printCurrentState() {
		if (currentState instanceof EmptyState)
			System.out.println(" which is now in empty state");
		else if (currentState instanceof NormalState)
			System.out.println(" which is now in normal state");
		else if (currentState instanceof FullState)
			System.out.println(" which is now in full state");
	}
}
