package state.jcooper;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.event.ActionListener;
import javax.swing.JToggleButton;

import jcooper_support.ICommand;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class CircleButton extends JToggleButton implements ICommand {
	private static final long serialVersionUID = 0L;

	private Mediator _mediator;

	public CircleButton(ActionListener actionListener, Mediator mediator) {
		super(" ");
		setSize(new Dimension(35, 35));
		setBorderPainted(true);
		setMargin(new Insets(5, 12, 5, 12));
		setToolTipText("Draw circle");
		addActionListener(actionListener);
		_mediator = mediator;
		_mediator.registerCircleButton(this);
	}

	public Dimension getPreferredSize() {
		return new Dimension(35, 35);
	}

	public void paint(Graphics g) {
		super.paint(g);
		int h = getHeight();
		// int w = getWidth();
		g.setColor(Color.black);
		g.drawArc(2, 2, h - 4, h - 4, 0, 360);
	}

	public void execute() {
		_mediator.startCircle();
	}
}
