package state.jcooper;

import java.awt.Insets;
import java.awt.event.ActionListener;
import javax.swing.JButton;

import jcooper_support.ICommand;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class ClearButton extends JButton implements ICommand {
	private static final long serialVersionUID = 0L;

	private Mediator _mediator;

	public ClearButton(ActionListener actionListener, Mediator mediator) {
		super("C");
		setMargin(new Insets(5, 12, 5, 12));
		setToolTipText("Clear");
		addActionListener(actionListener);
		_mediator = mediator;
	}
	public void execute() {
		_mediator.clear();
	}
}
