package state.jcooper;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.JPanel;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class JCanvas extends JPanel {
	private static final long serialVersionUID = 0L;

	private Mediator _mediator;

	public JCanvas(Mediator mediator) {
		_mediator = mediator;
		_mediator.registerCanvas(this);
		setBackground(Color.white);
	}

	public void paint(Graphics g) {
		super.paint(g);
		_mediator.reDraw(g);
	}
}
