/*
   2009/09/11
*/
package state.jcooper;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern State.");
		System.out.println();
		System.out.println("Intent: Allow an object to alter its behavior when its internal");
		System.out.println("state changes. The object will appear to change its class.");
		System.out.println();
		System.out.println("This example is a drawing program (similar to that of Memento) with");
		System.out.println("toolbar buttons for Select, Rectangle, Fill, Circle and Clear.");
		System.out.println("Each tool button does something different when selected and you click");
		System.out.println("or drag your mouse across the screen. Thus, the state of the graphical");
		System.out.println("editor affects the observed behavior.");
		System.out.println();
		System.out.println("1. If Pick is selected, clicking inside a drawing element highlights it or makes it appear with \"handles\".");
		System.out.println("   If the mouse is dragged with a drawing element already selected, the element moves on the screen.");
		System.out.println("2. If Rect is selected, clicking on the screen creates a new rectangle drawing element.");
		System.out.println("3. If Fill button is selected with a drawing element selected, that element is filled with the current color.");
		System.out.println("   If no drawing is selected, then clicking inside a drawing should fill it with the current color.");
		System.out.println("4. If Circle is selected, clicking on the screen creates a new circle drawing element.");
		System.out.println("5. If Clear is selected, all the drawing elements are removed.");
		System.out.println();
		System.out.println("Each button action comprises a different State.");
	}
	public static void main(String[] args) {
		printHelpMessage();
		new Window4State();
	}
}
