package state.jcooper;

import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;
import javax.swing.JToggleButton;

import jcooper_support.ICommand;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class PickButton extends JToggleButton implements ICommand {
	private static final long serialVersionUID = 0L;

	private Mediator _mediator;

	public PickButton(ActionListener actionListener, Mediator mediator) {
		super(new ImageIcon("arrow.gif"));
		setSize(new Dimension(35, 35));
		setBorderPainted(true);
		setMargin(new Insets(0, 0, 0, 0));
		setToolTipText("Select drawing element");
		addActionListener(actionListener);
		_mediator = mediator;
		_mediator.registerPickButton(this);
	}

	public void execute() {
		_mediator.startArrow();
	}
}
