package state.jcooper;

import java.awt.Insets;
import java.awt.event.ActionListener;
import javax.swing.JButton;

import jcooper_support.ICommand;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class UndoButton extends JButton implements ICommand {
	private static final long serialVersionUID = 0L;

	private Mediator _mediator;

	public UndoButton(ActionListener actionListener, Mediator mediator) {
		super("U");
		// setSize(new Dimension(25,25));
		setMargin(new Insets(5, 12, 5, 12));
		setToolTipText("Undo");
		addActionListener(actionListener);
		_mediator = mediator;
	}

	public void execute() {
		_mediator.undo();
	}
}
