package state.jcooper;

import java.awt.Color;
import java.awt.Graphics;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class VisibleCircle extends Drawing {
	public VisibleCircle(int xPt, int yPt) {
		x = xPt;
		y = yPt;
		w = 40;
		h = 30;
		saveAsRect();
	}

	public void draw(Graphics g) {
		g.drawArc(x, y, w, h, 0, 360);
		if (filled) {
			g.setColor(fillColor);
			g.fillArc(x, y, w, h, 0, 360);
		}
		if (selected) {
			g.setColor(Color.black);
			g.fillRect(x + w / 2, y - 2, 4, 4);
			g.fillRect(x - 2, y + h / 2, 4, 4);
			g.fillRect(x + w / 2, y + h - 2, 4, 4);
			g.fillRect(x + w - 2, y + h / 2, 4, 4);
		}
	}
}

/*class CircleMemento extends Memento {
	private VisibleCircle _circle;
	// saved fields- remember internal fields
	// of the specified visual rectangle
	int x, y, w, h;

	public CircleMemento(VisibleCircle visibleCircle) {
		super(visibleCircle);
		_circle _drawing = visibleCircle;
		x = _circle _drawing.x;
		y = _circle _drawing.y;
		w = _circle _drawing.w;
		h = _circle _drawing.h;
	}

	public void restore() {
		// restore the internal state of the specified circle
		_circle _drawing.x = x;
		_circle _drawing.y = y;
		_circle _drawing.h = h;
		_circle _drawing.w = w;
	}
}*/
