package state.jcooper;

import java.awt.Color;
import java.awt.Graphics;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 */
public class VisibleRectangle extends Drawing {
	public VisibleRectangle(int xPt, int yPt) {
		x = xPt;
		y = yPt;
		w = 40;
		h = 30;
		saveAsRect();
	}

	public void draw(Graphics g) {
		g.drawRect(x, y, w, h);
		if (filled) {
			g.setColor(fillColor);
			g.fillRect(x, y, w, h);
		}
		if (selected) {
			g.setColor(Color.black);
			g.fillRect(x + w / 2, y - 2, 4, 4);
			g.fillRect(x - 2, y + h / 2, 4, 4);
			g.fillRect(x + w / 2, y + h - 2, 4, 4);
			g.fillRect(x + w - 2, y + h / 2, 4, 4);
		}
	}
}

/*class RectangleMemento extends Memento {
//	private VisibleRectangle _rectangle;
	// saved fields- remember internal fields
	// of the specified visual rectangle
//	private int x, y, w, h;

	public RectangleMemento(VisibleRectangle visibleRectangle) {
		super(visibleRectangle);
		_rectangle _drawing = visibleRectangle;
		x = _rectangle _drawing.x;
		y = _rectangle _drawing.y;
		w = _rectangle _drawing.w;
		h = _rectangle _drawing.h;
	}

	public void restore() {
		// restore the internal state of the specified rectangle
		_rectangle _drawing.x = x;
		_rectangle _drawing.y = y;
		_rectangle _drawing.h = h;
		_rectangle _drawing.w = w;
	}
}*/
