package strategy.hk;

/**
 * Implements the linear sort sorting strategy for int arrays.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class LinearSort {

	/**
	 * Helper method that exchanges two values in an int array
	 */
	private void exchange(int[] numbers, int pos1, int pos2) {
		int tmp = numbers[pos1];
		numbers[pos1] = numbers[pos2];
		numbers[pos2] = tmp;
	}

	/**
	 * Sorts an int array
	 */
	public void sort(int[] numbers) {
		System.out.print("Sorting by LinearSort...");
		int lowest = 0;

		for (int start = 0; start < numbers.length; start++) {
			lowest = start;

			for (int current = start; current < numbers.length; current++) {
				if (numbers[current] < numbers[lowest]) {
					lowest = current;
				}
			}
			exchange(numbers, start, lowest);
		}
		System.out.println("done.");
	}
}
