package strategy.jcooper;

import java.awt.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class BarPlotStrategy extends PlotStrategy {
	private static final long serialVersionUID = 0L;
	private BarPlotPanel bp;

	public BarPlotStrategy() {
		super("Bar Plot");
		bp = new BarPlotPanel();
		getContentPane().add(bp);
	}

	public void plot(float xp[], float yp[]) {
		x = xp;
		y = yp; // copy in data
		findBounds(); // find maxes and mins
		setSize(width, height);
		setVisible(true); // show frame
		bp.setBackground(Color.white);
		bp.setBounds(minX, minY, maxX, maxY);
		bp.plot(x, y, Color.black); // plot data
	}
}
