package strategy.jcooper;

import java.awt.*;
import java.util.*;

import jcooper_support.InputFile;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class ContextBase {
	private float x[], y[];

	public ContextBase() {
		setPlotStrategy(new LinePlotStrategy());
	}

	public void setPlotStrategy(PlotStrategy ps) {
	}

	public void plot() {
	}

	public void setPenColor(Color c) {
	}

	public void readData(String filename) {
		StringTokenizer tok;
		InputFile f = new InputFile(filename);
		Vector<String> xv = new Vector<String>();
		Vector<String> yv = new Vector<String>();
		String s = "";
		// read data into 2 Vectors
		while (s != null) {
			s = f.readLine(); // read a line at a time
			if (s != null) {
				tok = new StringTokenizer(s);
				xv.addElement(tok.nextToken()); // x data
				yv.addElement(tok.nextToken()); // y data
			}
		}
		f.close();
		// copy data into two float arrays
		x = new float[xv.size()];
		y = new float[yv.size()];
		for (int i = 0; i < xv.size(); i++) {
			x[i] = new Float((String) xv.elementAt(i)).floatValue();
			y[i] = new Float((String) yv.elementAt(i)).floatValue();
		}
	}
}
