package strategy.jcooper;

import java.awt.event.ActionListener;
import javax.swing.JButton;

import jcooper_support.ICommand;


/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class JBarButton extends JButton implements ICommand {
	private static final long serialVersionUID = 0L;

	private String _fileName;
	private ContextBase context;

	public JBarButton(ActionListener act, String fileName, ContextBase ctx) {
		super("Bar graph");
		addActionListener(act);
		_fileName = fileName;
		context = ctx;
	}

	public void execute() {
		context.readData(_fileName); // "C:/Users/not/workspace/Patterns/src/strategy/JamesCooper/data.txt"
		context.setPlotStrategy(new BarPlotStrategy());
		context.plot();
	}
}
