package strategy.jcooper;

import java.awt.Color;
import java.awt.event.ActionListener;
import javax.swing.JButton;

import jcooper_support.ICommand;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class JGraphButton extends JButton implements ICommand {
	private static final long serialVersionUID = 0L;

	private String _fileName;
	private ContextBase context;

	public JGraphButton(ActionListener act, String fileName, ContextBase ctx) {
		super("Line graph");
		addActionListener(act);
		_fileName = fileName;
		context = ctx;
	}

	public void execute() {
		context.setPenColor(Color.red); // set color of plot
		context.setPlotStrategy(new LinePlotStrategy()); // set kind of plot
		// read the data:
		context.readData(_fileName); // "C:/Users/not/workspace/Patterns/src/strategy/JamesCooper/data.txt"
		context.plot(); // plot the data
	}
}
