package strategy.jcooper;

import java.awt.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class LinePlotPanel extends PlotPanel {
	private static final long serialVersionUID = 0L;

	public void paint(Graphics g) {
		int xp = calcx(x[0]); // get first point
		int yp = calcy(y[0]);
		g.setColor(Color.white); // flood background
		g.fillRect(0, 0, getWidth(), getHeight());
		g.setColor(Color.black);
		// draw bounding rectangle
		g.drawRect(xpmin, ypmin, xpmax, ypmax);
		g.setColor(color);
		// draw line graph
		for (int i = 1; i < x.length; i++) {
			int xp1 = calcx(x[i]);
			int yp1 = calcy(y[i]);
			g.drawLine(xp, yp, xp1, yp1);
			xp = xp1;
			yp = yp1;
		}
	}
}
