package strategy.jcooper;

import java.awt.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class LinePlotStrategy extends PlotStrategy {
	private static final long serialVersionUID = 0L;

	private LinePlotPanel lp;

	public LinePlotStrategy() {
		super("Line plot");
		lp = new LinePlotPanel();
		getContentPane().add(lp);
	}

	public void plot(float[] xp, float[] yp) {
		x = xp;
		y = yp; // copy in data
		findBounds(); // sets maxes and mins
		setSize(width, height);
		setVisible(true);
		setBackground(Color.white);
		lp.setBounds(minX, minY, maxX, maxY);
		lp.plot(xp, yp, color); // set up plot data
		repaint(); // call paint to plot
	}
}
