/*
   2009/09/23
*/
package strategy.jcooper;

import jcooper_support.Support;

import org.objectteams.Team;


/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Strategy.");
		System.out.println();
		System.out.println("Intent: Define a family of algorithms, encapsulate each one,");
		System.out.println("and make them interchangeable. Strategy lets the algorithm");
		System.out.println("vary independently from clients that use it.");
		System.out.println();
		System.out.println("This example is a simplified graphing program that presents data");
		System.out.println("as a line graph or a bar chart. The window that appears has two");
		System.out.println("buttons that call the two plots. Each of the buttons is a command");
		System.out.println("object that sets the correct strategy and then calls the Contexts");
		System.out.println("plot method. Method plot of Context selects one of the strategies");
		System.out.println("to be used for plotting.");
	}

	public static void main(String[] args) {
		printHelpMessage();
		PlotStrategyTeam pst = new PlotStrategyTeam();
		pst.activate(Team.ALL_THREADS);
		new Window4Strategy(Support.FOLDER_LOCATION + "\\" + "data.txt");
	}
}
