package strategy.jcooper;

import strategy.StrategyProtocol;
import java.awt.Color;
/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class PlotStrategyTeam extends StrategyProtocol {

	public class Strategy playedBy PlotStrategy {
	}

	public class Context playedBy ContextBase {
		float[] getY() -> get float[] y;
		float[] getX() -> get float[] x;
		private PlotStrategy plotStrategy;

		callin void setPlotStrategy(PlotStrategy ps) {
			this.plotStrategy = ps;
		}
		setPlotStrategy <- replace setPlotStrategy;

		callin void plot() {
			this.plotStrategy.plot(getX(), getY());
		}
		plot <- replace plot;

		callin void setPenColor(Color c) {
			plotStrategy.setPenColor(c);
		}
		setPenColor <- replace setPenColor;
	}
}
