package strategy.jcooper;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JPanel;

import jcooper_support.ICommand;
import jcooper_support.JxFrame;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Window4Strategy extends JxFrame implements ActionListener {
	private static final long serialVersionUID = 0L;

	private ContextBase context;

	public Window4Strategy(String fileName) {
		super("Strategy Plots. OT/J Example");
		JPanel jp = new JPanel();
		getContentPane().add(jp);
		context = new ContextBase();
		jp.add(new JBarButton(this, fileName, context));
		jp.add(new JGraphButton(this, fileName, context));
		setSize(new Dimension(300, 200));
		setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		ICommand comd = (ICommand) e.getSource();
		comd.execute();
	}
}
