package templateMethod.hk;

/**
 * Implements a ConcreteClass that decorates strings by turnung all
 * characters into lowercase and then capitalizing the consonants. It also
 * adds an explanation at the end.
 *
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class FancyGenerator {

    /**
     * Prepares a string for decoration. Turns the string into lowercase.
     *
     * @param s the string to filter
     * @return the prepared string
     */
	public String prepare(String s) {
		return s.toLowerCase();
	}

    /**
     * Filters a string. Capitalizes all consonants.
     *
     * @param s the string to filter
     * @return the filtered string
     */
	public String filter(String s) {
		s = s.replace('a', 'A'); 
		s = s.replace('e', 'E');
		s = s.replace('i', 'I'); 
		s = s.replace('o', 'O');
		s = s.replace('u', 'U');
		return s; 
	}

    /**
     * Finalizes a string by adding an explanation to isocelesTriangle.
     *
     * @param s the string to finalize
     * @return the finalized string
     */
	public String finalize(String s) {
		return (s+".\n(all vowels capitalized)");
	}
}
