package templateMethod.hk;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	/**
	 * Implements the driver for the Template Method design pattern example.
	 * <p>
	 * @param args the command line parameters, unused
	 */
	public static void main(String[] args) {
		String original = "This is the original string to be processed";

		TemplateTeam t1 = new TemplateTeam( new SimpleGenerator() );
		TemplateTeam t2 = new TemplateTeam(	new FancyGenerator() );

		System.out.println("<Original>");
		System.out.println(original);
		System.out.println("<SimpleGenerator>");
		System.out.println(t1.generate(original));
		System.out.println("<FancyGenerator>");
		System.out.println(t2.generate(original));
	}
}
