package templateMethod.hk;

/**
 * Implements a ConcreteClass that decorates strings by adding a period
 * at the end of them.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class SimpleGenerator {

	/**
	 * Prepares a string for decoration. Does nothing.
	 * 
	 * @param s the string to filter
	 * @return the passed string
	 */
	public String prepare(String s) {
		return s;
	}

	/**
	 * Filters a string. Converts all characters to upper case.
	 * 
	 * @param s the string to filter
	 * @return the passed string
	 */
	public String filter(String s) {
		return s.toUpperCase();
	}

	/**
	 * Finalizes a string by adding a period to isocelesTriangle.
	 * 
	 * @param s the string to finalize
	 * @return the finalized string
	 */
	public String finalize(String s) {
		return s + ".";
	}
}
