/*
   2009/09/04
*/
package templateMethod.jcooper;

import org.objectteams.Team;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class Main {
	private static void printHelpMessage() {
		System.out.println("Design pattern Template Method");
		System.out.println();
		System.out.println("Intent: define the skeleton of an algorithm in an operation, deferring");
		System.out.println("some steps to subclasses. Template Method lets subclasses redefine");
		System.out.println("certain steps of an algorithm without changing the algorithm's structure.");
		System.out.println();
		System.out.println("In this example, the template method is the logic to");
		System.out.println("draw triangles. It only draws the first and last lines.");
		System.out.println("There is one hook method - draw2ndLine - that ");
		System.out.println("draws a line to the third point.");
	}
	public static void main(String[] args) {
		printHelpMessage();
		new TriangleTeam().activate(Team.ALL_THREADS);
		new Window4TemplateMethod();
	}
}
