package templateMethod.jcooper;

import java.awt.*;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public abstract class Triangle {
	private Point p1, p2, p3;

	public Triangle(Point a, Point b, Point c) {
		// save
		p1 = a;
		p2 = b;
		p3 = c;
	}

	// The hook method that has to be implemented for each triangle type:
	abstract public Point draw2ndLine(Graphics g, Point a, Point b);

	public void draw(Graphics g) {
	}

	public Point getP1() {
		return p1;
	}

	public Point getP2() {
		return p2;
	}

	public Point getP3() {
		return p3;
	}
}
