package visitor.hk1;

/**
 * Implements a ConcreteElement of the aggregate structure. This is a
 * terminal binary tree element (leaf).
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class BinaryTreeLeaf extends TreeNode {

	/**
	 * the value stored in this leaf
	 */
	protected int value;

	/**
	 * Creates a new <code>BinaryTreeLeaf</code> with the given value.
	 * 
	 * @param value
	 *            the value of the leaf
	 */
	public BinaryTreeLeaf(int value) {
		this.value = value;
	}

	/**
	 * Accessor for the leaf's value
	 * 
	 * @return the leaf's value
	 */
	public int getValue() {
		return value;
	}
}
