package visitor.hk1;

/**
 * Implements a ConcreteElement of the aggregate structure. This is a
 * non-terminal binary tree element.
 * 
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public class BinaryTreeNode extends TreeNode {

	/**
	 * Creates a non-terminal node of a binary tree.
	 * 
	 * @param left
	 *            the new left subtree.
	 * @param right
	 *            the new left subtree.
	 */
	public BinaryTreeNode(TreeNode left, TreeNode right) {
		this.left = left;
		this.right = right;
	}

	/**
	 * the left subtree
	 */
	protected TreeNode left;

	/**
	 * the right subtree
	 */
	protected TreeNode right;

	/**
	 * Accessor for the left subtree.
	 * 
	 * @return the left subtree.
	 */
	public TreeNode getLeft() {
		return left;
	}

	/**
	 * Accessor for the right subtree.
	 * 
	 * @return the right subtree.
	 */
	public TreeNode getRight() {
		return right;
	}
}
