package visitor.hk1;

import visitor.VisitorProtocol;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class SummationVisitorTeam extends VisitorProtocol {
	private SummationVisitor sv;

	public class VisitableNode playedBy TreeNode {
		// public void accept(Visitor visitor){}
	}

	protected class Leaf playedBy BinaryTreeLeaf {
		public abstract int getValue();

		getValue -> getValue;
	}

	protected class Node playedBy BinaryTreeNode {
		public abstract VisitableNode getLeft();

		VisitableNode getLeft() -> TreeNode getLeft() with {
			result <- treeNode2VisitableNode(result)
		}

		public abstract VisitableNode getRight();

		VisitableNode getRight() -> TreeNode getRight() with {
			result <- treeNode2VisitableNode(result)
		}

	}

	public class SummationVisitor extends Visitor {
		int sum = 0;

		public SummationVisitor(String message) {
			// super(message);
		}

		public String report() {
			return ">>> SummationVisitor collected a sum of: " + sum;
		}

		public void visitLeaf(VisitableNode node) {
			Leaf leaf = (Leaf) node;
			sum += leaf.getValue();
		}

		public void visitNode(VisitableNode node) {
			Node rnode = (Node) node;
			rnode.getLeft().accept(this);
			rnode.getRight().accept(this);
		}
	}

	public void acceptVisit(TreeNode as VisitableNode node) {
		sv = new SummationVisitor("summation visitor");
		node.accept(sv);
	}

	public VisitableNode treeNode2VisitableNode(TreeNode as VisitableNode n) {
		return n;
	}

	public String visitorReport() {
		if (sv == null) {
			System.err.println("must visit before asking for a report");
			return null;
		}
		return sv.report();
	}
}
