package visitor.hk1;

import visitor.VisitorProtocol;

/**
 * @author Jan Hannemann, Gregor Kiczales - original Java/AspectJ example
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class TraversalVisitorTeam extends VisitorProtocol {
	private TraversalVisitor tv;

	protected class Leaf playedBy BinaryTreeLeaf {
		public abstract int getValue();
		getValue -> getValue;
	}
	
	public class VisitableNode playedBy TreeNode {
		public void accept(Visitor visitor){
		}
	}

	public VisitableNode treeNode2VisitableNode(TreeNode as VisitableNode n) {
		return n;
	}

    protected class Node playedBy BinaryTreeNode {
    	public abstract VisitableNode getLeft();

    	VisitableNode getLeft() -> TreeNode getLeft() with {
    		result <- treeNode2VisitableNode(result)
    	}

    	public abstract VisitableNode getRight();
    	VisitableNode getRight() -> TreeNode getRight() with{
    		result <- treeNode2VisitableNode(result)
    	}
    }
	
	public class TraversalVisitor extends Visitor{
		String result = "";

		public TraversalVisitor (String message){
			//super(message);
		}
		
		public String report() {
			return ">>> TraversalVisitor traversed the tree to: "+result;
		}
		
		public void visitLeaf(VisitableNode node) {
			Leaf leaf = (Leaf) node;
			result += leaf.getValue();
		}

		public void visitNode(VisitableNode node) {			
			Node rnode = (Node) node;
			result += "{";
			rnode.getLeft().accept(this);
			result += ",";
			rnode.getRight().accept(this);
			result += "}";
		}

	}

	public void acceptVisit(TreeNode as VisitableNode node){
		tv = new TraversalVisitor("traversal visitor");
		node.accept(tv);
	}

//	public <AnyBase base VisitableNode> void acceptVisit(AnyBase as VisitableNode node){
//		sv = new SummationVisitor();
//		node.accept(sv);
//	}

	public String visitorReport() {
		if(tv == null){
			System.err.println("must visit before asking for a report");
			return null;
		}
		return tv.report();
	}
}
