/*
   22 de Mai de 2010
*/
package visitor.hk2;

/**
 * @author Miguel P. Monteiro
 * This Visitor collects a string description of the tree like {{1,2},3}.
 */
public team class PrintVisitorTeam {
	protected class ToplevelRole playedBy TreeNode {
		public String getRepresentation() {
			return ""; //this method is not supposed to be called, ever
		}
	}
	protected class TreeLeafRole extends ToplevelRole playedBy BinaryTreeLeaf {
		public abstract String getRepresentation();
		String getRepresentation() -> int getValue() with {
			result <- Integer.toString(result)
		};
	}
	protected class TreeNodeRole extends ToplevelRole playedBy BinaryTreeNode {
		public abstract ToplevelRole getLeft();
		getLeft -> getLeft;
		public abstract ToplevelRole getRight();
		getRight -> getRight;

		public String getRepresentation() {
			return "{" + getLeft().getRepresentation() + "," + getRight().getRepresentation() + "}";
		}
	}
	/** 
	 * Returns the result of the visitor's operation
	 * @return a string representing a traversal of the tree
	 */
	public String report(TreeNode as ToplevelRole structure) {
		return
			">>> TraversalVisitor traversed the tree to: " +
			structure.getRepresentation();
	}
}
