package visitor.jcooper1;

import visitor.VisitorProtocol;
import java.util.Vector;

/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object Teams/Java
 */
public team class VacationVisitorTeam extends VisitorProtocol {
	private EmpVisitor employeeVisitor;

	public class Boss2Visit extends Node playedBy Boss {
		public abstract int getVacDays();
		getVacDays -> getVacDays;
	}	

	public class Employee2Visit extends Leaf playedBy Employee {
		public abstract int getVacDays();
		getVacDays -> getVacDays;
	}

	public class EmpVisitor extends Visitor {
		int total_days;
		protected EmpVisitor(){
			total_days = 0;
		}

		public String report() {
			return null;
		}
		
		public int getTotalDays() {
			return total_days;
		}

		//visit employee
		public void visitLeaf(VisitableNode node) {
			Employee2Visit employee = (Employee2Visit) node;
			total_days += employee.getVacDays();
		}

		//visit boss
		public void visitNode(VisitableNode node) {
			Boss2Visit boss = (Boss2Visit) node;
			total_days += boss.getVacDays();
		}
	}

	public void visitEmployees(Employee[] _employees) {
		employeeVisitor = new EmpVisitor();
		for (int i = 0; i < _employees.length; i++) {
			this.acceptVisit(_employees[i]);
		}
	}

	public <AnyBase base VisitableNode>void acceptVisit(AnyBase as VisitableNode node) {
		node.accept(employeeVisitor);
	}

	public int getTotalDays() {
		if(employeeVisitor == null){
			System.err.println("must visit before asking for a report");
			return 0;
		}
		return employeeVisitor.getTotalDays();
	}
}