package visitor.jcooper2;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;

import jcooper_support.*;


/**
 * @author James Cooper, adapted and refactored by Miguel P. Monteiro
 * @author Joao Gomes - adapted to Object ks/Java
 */
public class Window4Visitor extends JxFrame implements ActionListener {
	private static final long serialVersionUID = 0L;

	private JawtList _employeeList;
	private JTextField _total, _bossTotal;
	private JButton _vacationButton;
	private Employee[] _employees;
	private EmployeeVacationVisitorTeam _employeeVacationVisitorTeam; 
	private BossVacationVisitorTeam _bossVacationVisitorTeam;

	public Window4Visitor(Employee[] employees, EmployeeVacationVisitorTeam employeeVacationVisitor, BossVacationVisitorTeam bossVacationVisitor) {
		super("Vacation Display");
		_employees = employees;
		_employeeVacationVisitorTeam = employeeVacationVisitor;
		_bossVacationVisitorTeam = bossVacationVisitor;
		JPanel panel = new JPanel();
		getContentPane().add(panel);
		panel.setLayout(new GridLayout(1, 2));
		_employeeList = new JawtList(10);
		panel.add(_employeeList);
		for (int i = 0; i < _employees.length; i++) {
			_employeeList.add(_employees[i].getName());
		}
		Box box = Box.createVerticalBox();
		panel.add(box);
		_total = new JTextField(5);
		_total.setHorizontalAlignment(JTextField.CENTER);
		box.add(_total);
		box.add(Box.createVerticalStrut(10));
		_bossTotal = new JTextField(5);
		_bossTotal.setHorizontalAlignment(JTextField.CENTER);
		box.add(_bossTotal);
		box.add(Box.createVerticalStrut(10));
		_vacationButton = new JButton("Vacations");
		box.add(_vacationButton);
		_vacationButton.addActionListener(this);
		setSize(300, 200);
		setVisible(true);
		_total.setText("  ");
		_total.setBackground(Color.white);
	}

	public void actionPerformed(ActionEvent e) {
		_total.setText(new Integer(_employeeVacationVisitorTeam.getDays4AllStaff(_employees)).toString());
		_bossTotal.setText(new Integer(_bossVacationVisitorTeam.getDays4AllStaff(_employees)).toString());
	}
}
